SystemOrganization addCategory: #'Pier-Model-Core'!
SystemOrganization addCategory: #'Pier-Model-Kernel'!
SystemOrganization addCategory: #'Pier-Model-Structure'!
SystemOrganization addCategory: #'Pier-Model-Document'!
SystemOrganization addCategory: #'Pier-Model-Command'!
SystemOrganization addCategory: #'Pier-Model-Persistence'!
SystemOrganization addCategory: #'Pier-Model-Magritte'!
SystemOrganization addCategory: #'Pier-Model-Exception'!
SystemOrganization addCategory: #'Pier-Model-Utilities'!
SystemOrganization addCategory: #'Pier-Model-Visitor'!

!MAVisitor methodsFor: '*pier-model-accessing' stamp: 'lr 3/9/2006 11:29'!
context
	^ PRCurrentContext value! !

!MAVisitor methodsFor: '*pier-model-accessing' stamp: 'lr 3/9/2006 11:29'!
context: aContext
	PRCurrentContext value: aContext! !

!MAVisitor methodsFor: '*pier-model-visiting-description' stamp: 'lr 3/9/2006 11:29'!
visitStructureDescription: anObject
	^ self visitElementDescription: anObject! !

MACompatibility subclass: #PRCompatibility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Core'!

!PRCompatibility class methodsFor: 'development-tools' stamp: 'lr 3/9/2006 11:30'!
compileFileNamed: aString into: aClass selector: aSelector
	"Reads the file with the name aString and compile it into aClass>>aSelector returning the the contents as byte-array."

	| input contents source |
	input := FileDirectory default oldFileNamed: aString.
	contents := [ input binary; contents ] ensure: [ input close ].
	source := String streamContents: [ :stream |
		stream nextPutAll: aSelector; cr.
		stream tab; nextPut: $"; nextPutAll: self name; nextPutAll: ' compileFileNamed: '; print: aString; nextPutAll: ' into: '; print: aClass; nextPutAll: ' selector: '; print: aSelector; nextPut: $"; cr; cr.
		stream tab; nextPutAll: '^ #('.
		contents asByteArray
			do: [ :element | element printOn: stream ]
			separatedBy: [ stream space ].
		stream nextPutAll: ') asByteArray.' ].
	aClass compile: source classified: #'accessing-resources'! !

!PRCompatibility class methodsFor: 'environment' stamp: 'lr 3/9/2006 11:30'!
hashPassword: aString
	"Answer a secure-hash value to be used to store and compare passwords in a save way."

	^ SecureHashAlgorithm new hashMessage: aString! !

MADistribution subclass: #PRDistribution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Core'!

!PRDistribution class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
package
	"The SqueakMap package name."

	^ 'Pier'! !

!PRDistribution class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
packages
	^ #( ( 'Pier-Model' )
		 ( 'Pier-Tests' 'Smalltalk includesKey: #TestCase' )
		 ( 'Pier-Seaside' 'Smalltalk includesKey: #WAComponent' )
		 ( 'Pier-OmniBrowser' 'Smalltalk includesKey: #OBBrowser' ) )! !

!PRDistribution class methodsFor: 'execution' stamp: 'lr 3/9/2006 11:30'!
postload
	self registerRepository: 'http://mc.lukas-renggli.ch/pier'! !

!PRDistribution class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
preamble
	^ '(SMSqueakMap default packageWithName: ''Magritte'')
	lastRelease install.' , String cr! !

!PRDistribution class methodsFor: 'accessing' stamp: 'lr 10/30/2006 22:18'!
version
	"The first item is the product name, which should only contain lowercase letters. Then the version numbers are following, that are made up of three numbers. An optimal suffix alpha, beta, pre or rc follows. External packages or extensions might want to call this method to check the version required to run."

	^ #( pier 1 0 7 alpha )! !

!Object methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	self subclassResponsibility! !

!Object methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
acceptDecorated: aVisitor
	self accept: aVisitor! !

Object subclass: #PRMacroExpander
	instanceVariableNames: 'character table default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

PRMacroExpander class
	instanceVariableNames: 'Default'!

PRMacroExpander class
	instanceVariableNames: 'Default'!

!PRMacroExpander class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
default
	^ Default! !

!PRMacroExpander class methodsFor: 'class initialization' stamp: 'lr 3/9/2006 11:30'!
initialize
	Default := self on: (Dictionary new
		at: $c put: [ :char :context | context command name ];		" current command "
		at: $r put: [ :char :context | context kernel root title ];		" current root structure "
		at: $t put: [ :char :context | context structure title ];			" current structure "
		at: $k put: [ :char :context | context kernel name ];			" current kernel name "
		yourself)! !

!PRMacroExpander class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
on: aDictionary
	^ self new
		table: aDictionary;
		yourself! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
character
	^ character! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
character: aCharacter
	character := aCharacter! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
default
	^ default! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
default: aBlock
	default := aBlock! !

!PRMacroExpander methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultCharacter
	^ $%! !

!PRMacroExpander methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultDefault
	^ [ :char |
		self character = char
			ifTrue: [ String with: self character ]
			ifFalse: [ String with: self character with: char ] ]! !

!PRMacroExpander methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultTable
	^ Dictionary new! !

!PRMacroExpander methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
expand: aReadStream using: anArray
	^ String streamContents: [ :writeStream |
		[ aReadStream atEnd ] whileFalse: [
			writeStream nextPutAll: (aReadStream upTo: self character).
			aReadStream atEnd ifFalse: [
				self
					expand: aReadStream
					using: anArray
					to: writeStream ] ] ]! !

!PRMacroExpander methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
expand: aReadStream using: anArray to: aWriteStream
	| char block |
	block := self table
		at: (char := aReadStream next)
		ifAbsent: [ self default ].
	^ aWriteStream nextPutAll: (block
		valueWithPossibleArgs: (anArray
			copyWithFirst: char))! !

!PRMacroExpander methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	self table: self defaultTable.
	self character: self defaultCharacter.
	self default: self defaultDefault! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
table
	^ table! !

!PRMacroExpander methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
table: aDictionary
	table := aDictionary! !

!PRMacroExpander methodsFor: 'evaluation' stamp: 'lr 3/9/2006 11:29'!
value: aString
	^ self value: aString withArguments: Array new! !

!PRMacroExpander methodsFor: 'evaluation' stamp: 'lr 3/9/2006 11:29'!
value: aString value: anObject
	^ self value: aString withArguments: (Array with: anObject)! !

!PRMacroExpander methodsFor: 'evaluation' stamp: 'lr 3/9/2006 11:29'!
value: aString withArguments: anArray
	^ self expand: aString readStream using: anArray! !

Object subclass: #PRObject
	instanceVariableNames: 'properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Core'!

!PRObject commentStamp: 'lr 5/28/2006 17:00' prior: 0!
I am the root of objects within Pier. I hold a dictionary of properties, so that users can easily annotate me with new values. I am visitable.!

PRObject subclass: #PRCommand
	instanceVariableNames: 'context answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRCommand commentStamp: 'lr 6/2/2006 11:42' prior: 0!
I am an abstract superclass of the command pattern in Pier. All modifications to the model have to be done through subclasses of myself, else they do not get properly logged with the persistency mechanism. I hold the context in which the receiver is executed in the instance variable context. To modify the resulting context, create a copy of the current context and store it in the instance variable answer.

The following event-handlers are called when executing an action in the given order. Do override these messages to customize the command, never override the other internal methods:
- Override the message <code>#doValidate</code> to check the valid setup of the command and to raise exceptions in case any precondition isn't met. Speak here or forever have your peace!! Don't change the model in there.
- Override the message <code>#doExecute</code> to execute the actual command. Do not raise exceptions in there, catch all the problems in <code>#doValidate</code>.
- Override the message <code>#doPersistency</code> to save the command that has been just executed with the current persistency strategy. Most commands don't need to override this message and just stick with the default behavior.
- Override the message <code>#doAnswer</code> to create the answer context. Most commands don't need to override this message and just stick with the default behavior.

Do not play with funny jumpy things, such as resumable exceptions or continuations, inside the code of the command hierarchy or you will very likely run into severe problems.!

PRCommand subclass: #PRAddCommand
	instanceVariableNames: 'name type link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRAddCommand commentStamp: '<historical>' prior: 0!
I'm a command used to add new structures to your structures. My code is very interesting if you want to understand how Pier is designed.

Type is the class (subclass of PRStructure) for which a new instance will be created.!

!PRAddCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $a! !

!PRAddCommand class methodsFor: 'accessing-description' stamp: 'lr 3/11/2006 17:40'!
descriptionName
	^ (MAStringDescription selector: #name label: 'Name' priority: 100)
		beRequired;
		yourself! !

!PRAddCommand class methodsFor: 'accessing-description' stamp: 'lr 5/5/2006 19:07'!
descriptionType
	^ (MASingleOptionDescription selector: #type label: 'Type' priority: 110 default: PRPage)
		options: (MADynamicObject on: [ self structureClasses ]);
		reference: MAClassDescription new;
		beRequired;
		beSorted;
		yourself! !

!PRAddCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRAddCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Add'! !

!PRAddCommand class methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
structureClasses
	^ PRCurrentContext value in: [ :context |
		PRStructure withAllConcreteClasses select: [ :each |
			(context structure class canBeParentOf: each)
				and: [ each canBeChildOf: context structure class ] ] ]! !

!PRAddCommand methodsFor: 'private' stamp: 'lr 9/6/2006 13:29'!
child
	"Create a new structure of the selected species, a subclass of PRStructure. Set the title if necessary, else it will be generated automatically."

	| child |
	child := self type named: self name.
	(self link notNil and: [ self link hasAlias ])
		ifTrue: [ child title: self link alias ].
	^ child! !

!PRAddCommand methodsFor: 'events' stamp: 'lr 9/25/2006 08:07'!
doExecute
	"Create a new structure of requested type and add it to the children list of the current structure. If possible the following context will be set to an editor or a view onto the new structure."

	| structure |
	super doExecute.
	self structure 
		addChild: (structure := self child).
	self answer: (self context
		structure: structure
		command: (structure editCommandClass notNil
			ifTrue: [ structure editCommandClass ]
			ifFalse: [ structure viewCommandClass ])
				new)! !

!PRAddCommand methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
doValidate
	"Verify that the new structure can be added before launching #doExecute. Basically, the title must be unique."

	super doValidate.
	self validateChild: self child in: self structure! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 9/6/2006 13:14'!
link
	^ link! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 9/6/2006 13:14'!
link: aLink
	link := aLink! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name
	^ name ifNil: [ name := self uniqueName: 'untitled' in: self structure ]! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name: aString
	name := aString! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
type
	^ type ifNil: [ type := PRPage ]! !

!PRAddCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
type: aClass
	type := aClass! !

!PRCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:57'!
accessKey
	^ nil! !

!PRCommand class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
context: aContext
	(self isValidIn: aContext)
		ifFalse: [ self error: self name , ' is not useable in the given context.' ].
	^ self new
		setContext: aContext;
		yourself! !

!PRCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidIn: aContext
	"Verify that a command as a meaning for the context aContext. Override this command to add new constraints that are static to the command."

	^ aContext structure isValidCommand: self in: aContext! !

!PRCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
shortLabel
	^ self label! !

!PRCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
structureClass
	^ PRStructure! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
answer
	"Return a new context that should be activated after executing this action."

	^ answer! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
answer: aContext
	"Set the resulting context of this command."

	answer := aContext! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
context
	"Return the current context of the receiver."

	^ context! !

!PRCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
context: aContext
	"Set the current context of the receiver."

	context := aContext! !

!PRCommand methodsFor: 'events' stamp: 'lr 5/27/2006 17:25'!
doAnswer
	"Override this message to create the answer context. Most commands don't need to override this message and just stick with the default behavior."

	self answer isNil
		ifTrue: [ self answer: (self context structure: self structure) ]! !

!PRCommand methodsFor: 'events' stamp: 'lr 5/27/2006 17:25'!
doExecute
	"Override this message to execute the actual command. Do not raise exceptions in there, catch all the problems in <code>#doValidate</code>."! !

!PRCommand methodsFor: 'events' stamp: 'lr 5/27/2006 17:25'!
doPersistency
	"Override this message to save the command-context that has been just executed with the current persistency strategy. Most commands don't need to override this message and just stick with the default behavior."

	self context setTimestamp: TimeStamp now.
	self kernel persistency log: self context! !

!PRCommand methodsFor: 'events' stamp: 'lr 9/11/2006 10:54'!
doValidate
	"Override this message to check the valid setup of the command and to raise exceptions in case any precondition isn't met. Speak here or forever have your peace!! Don't change the model in there."

	self structure validateCommand: self! !

!PRCommand methodsFor: 'actions' stamp: 'lr 5/28/2006 18:18'!
execute
	"Execute the command of the receiver. To implement your action in the code of one of my subclasses. Never override this message, but instead have a look at the different template methods (<code>#doValidate</code>, <code>#doExecute</code>, <code>#doPersistency</code>, <code>#doAnswer</code>) available in the events protocol."

	self isView
		ifTrue: [ self shouldNotImplement ].
	self kernel critical: [
		self doValidate; doExecute.
		self isLogged
			ifTrue: [ self doPersistency ] ].
	self doAnswer! !

!PRCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEdit
	^ false! !

!PRCommand methodsFor: 'testing' stamp: 'lr 5/27/2006 17:26'!
isLogged
	"Most commands are logged. This means they do modify the model and are therefore preserved in the history. However there are some that just display something or change the state of the current context and neither change the model nor need to be logged."

	^ true! !

!PRCommand methodsFor: 'testing' stamp: 'lr 5/27/2006 17:26'!
isQuick
	"Quick commands do not have a configuration interface (probably not even Magritte descriptions) and therefore should not be presented to the user but simply executed."

	^ false! !

!PRCommand methodsFor: 'testing' stamp: 'lr 5/27/2006 17:27'!
isView
	"Most commands are not a view. This means they override <code>#doExecute</code> to do something meaningful on the context or the model."

	^ false! !

!PRCommand methodsFor: 'accessing-delegated' stamp: 'lr 5/28/2006 21:10'!
kernel
	"Answer the kernel the receiver is working on."

	^ self context kernel! !

!PRCommand methodsFor: 'accessing-delegated' stamp: 'lr 3/9/2006 11:29'!
name
	^ self class label! !

!PRCommand methodsFor: 'accessing-delegated' stamp: 'lr 3/9/2006 11:29'!
root
	^ self context kernel root! !

!PRCommand methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setContext: aContext
	context := aContext! !

!PRCommand methodsFor: 'accessing-delegated' stamp: 'rjl 5/11/2006 22:36'!
structure
	^ self context structure! !

!PRCommand methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:29'!
timestamp
	^ self propertyAt: #timestamp ifAbsent: [ nil ]! !

!PRCommand methodsFor: 'accessing-properties' stamp: 'lr 3/9/2006 11:29'!
timestamp: aTimestamp
	self propertyAt: #timestamp put: aTimestamp! !

!PRCommand methodsFor: 'private' stamp: 'lr 9/25/2006 08:05'!
uniqueName: aString in: aStructure
	"Answer an unique structure name with the prefix aString within the parent aStructure."

	| index name |
	(aStructure isNil or: [ aStructure hasChildren not ])
		ifTrue: [ ^ aString ].
	(aStructure childrenDecoration includes: aString)
		ifFalse: [ ^ aString ].
	index := 1.
	[ aStructure childrenDecoration
		includes: (name := aString , ' ' , (index := index + 1) asString) ]
		whileTrue.
	^ name! !

!PRCommand methodsFor: 'validating' stamp: 'lr 5/29/2006 10:14'!
validateChild: aChildStructure in: aStructure
	"Make sure that <code>aChildStructure</code> can be added as child or replace an existing child in a <code>aStructure</code>."

	self validateChild: aChildStructure named: aChildStructure name in: aStructure! !

!PRCommand methodsFor: 'validating' stamp: 'lr 3/9/2006 11:29'!
validateChild: aChildStructure named: aString in: aStructure
	self validateName: aString of: aChildStructure in: aStructure.
	self validateNestingOf: aChildStructure in: aStructure! !

!PRCommand methodsFor: 'validating' stamp: 'lr 9/25/2006 08:34'!
validateName: aString of: aChildStructure in: aStructure
	"Make sure that <code>aChildStructure</code> with the title <code>aString</code> can be added as child or replace an existing child in a <code>aStructure</code>."

	| child |
	(aStructure isNil or: [ aStructure hasChildren not ])
		ifTrue: [ ^ self ].
	child := aStructure childrenDecoration
		at: aString
		ifAbsent: [ ^ self ].
	child ~= aChildStructure
		ifTrue: [ PRConflictingNameError in: aStructure title: aString ]! !

!PRCommand methodsFor: 'validating' stamp: 'lr 5/29/2006 10:14'!
validateNestingOf: aChildStructure in: aStructure
	"Make sure that <code>aChildStructure</code> can be added as child to <code>aStructure</code> and that <code>aStructure</code> can have <code>aChildStructure</code> as a child."

	aStructure isNil
		ifTrue: [ ^ self ].
	(aStructure canBeParentOf: aChildStructure)
		ifFalse: [ PRInvalidNestingError of: aChildStructure in: aStructure ].
	(aChildStructure canBeChildOf: aStructure)
		ifFalse: [ PRInvalidNestingError of: aChildStructure in: aStructure ]! !

PRCommand subclass: #PREditCommand
	instanceVariableNames: 'fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PREditCommand commentStamp: 'lr 8/29/2005 10:55' prior: 0!
Abstract command to edit structures.!

!PREditCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $e! !

!PREditCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PREditCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Edit'! !

!PREditCommand methodsFor: 'accessing' stamp: 'lr 5/24/2006 15:16'!
description
	^ self structure description select: [ :each | each isEditable ]! !

!PREditCommand methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
doExecute
	super doExecute.
	self fields keysAndValuesDo: [ :desc :value | self structure write: value using: desc ]! !

!PREditCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
fields
	^ fields ifNil: [ fields := Dictionary new ]! !

!PREditCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEdit
	^ true! !

!PREditCommand methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
readUsing: aDescription
	^ (self description includes: aDescription)
		ifFalse: [ super readUsing: aDescription ]
		ifTrue: [
			self fields
				at: aDescription
				ifAbsent: [ self structure readUsing: aDescription ] ]! !

!PREditCommand methodsFor: 'private' stamp: 'rjl 5/11/2006 22:39'!
write: anObject using: aDescription
	"this guard clause prevents this command from blowing up the deserialization of commands in PRFilePersistency, which is currently buggy for some reason, will remove once I chase down the error. - rjl"
	context ifNil:[^self].
	^ (self description includes: aDescription)
		ifFalse: [ super write: anObject using: aDescription ]
		ifTrue: [ self fields at: aDescription put: anObject ]! !

PRCommand subclass: #PRLocationCommand
	instanceVariableNames: 'name target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

PRLocationCommand subclass: #PRCopyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRCopyCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRCopyCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Copy'! !

!PRCopyCommand methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultName
	^ self uniqueName: self structure name , ' copy' in: self target! !

!PRCopyCommand methodsFor: 'events' stamp: 'lr 10/30/2006 20:37'!
doExecute
	| structure |
	super doExecute.
	structure := self target childrenDecoration
		add: (self structure copy
			name: self name;
			title: nil;
			yourself).
	structure incomingReferences
		toAll: (structure enumerator 
			with all hidden contents);
		do: [ :each | each update ].
	self answer: (self context
		structure: structure)! !

!PRLocationCommand class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionName
	^ (MAStringDescription selector: #name label: 'Name' priority: 110)
		beRequired;
		yourself! !

!PRLocationCommand class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionTarget
	^ (PRStructureDescription selector: #target label: 'Target' priority: 100)
		beRequired;
		yourself! !

!PRLocationCommand methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultName
	^ self structure name! !

!PRLocationCommand methodsFor: 'accessing-defaults' stamp: 'lr 3/9/2006 11:29'!
defaultTarget
	^ self structure parent! !

!PRLocationCommand methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
doValidate
	super doValidate.
	self validateChild: self structure named: self name in: self target! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name
	^ name ifNil: [ name := self defaultName ]! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name: aString
	name := aString! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target
	^ target ifNil: [ target := self defaultTarget ]! !

!PRLocationCommand methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target: aStructure
	target := aStructure! !

PRLocationCommand subclass: #PRMoveCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRMoveCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $m! !

!PRMoveCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRMoveCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidIn: aContext
	^ (super isValidIn: aContext)
		and: [ aContext structure isRoot not ]! !

!PRMoveCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Move'! !

!PRMoveCommand methodsFor: 'events' stamp: 'lr 10/30/2006 20:37'!
doExecute
	super doExecute.
	self structure name: self name.
	self target 
		addChild: self structure remove.
	self root incomingReferences
		toAll: (self structure enumerator 
			with all hidden contents);
		do: [ :each | each update ]! !

!PRMoveCommand methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
doValidate
	super doValidate.
	(self structure isAncestorOf: self target)
		ifTrue: [ PRInvalidNestingError of: self structure in: self target ]! !

PRCommand subclass: #PRRemoveCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRRemoveCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $r! !

!PRRemoveCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRRemoveCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidIn: aContext
	^ (super isValidIn: aContext)
		and: [ aContext structure isRoot not ]! !

!PRRemoveCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Remove'! !

!PRRemoveCommand methodsFor: 'events' stamp: 'lr 10/30/2006 20:37'!
doExecute
	super doExecute.
	self root incomingReferences
		toAll: (self structure enumerator
			with all hidden contents);
		do: [ :each | each target: nil ].
	self structure parent in: [ :parent |
		self structure remove.
		self answer: (self context
			structure: parent) ]! !

!PRRemoveCommand methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
doValidate
	super doValidate.
	self structure isRoot
		ifTrue: [ self error: 'Unable to remove root node.' ]! !

!PRRemoveCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isQuick
	^ true! !

PRCommand subclass: #PRViewCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Command'!

!PRViewCommand class methodsFor: 'accessing' stamp: 'lr 5/3/2006 16:58'!
accessKey
	^ $v! !

!PRViewCommand class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRViewCommand class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'View'! !

!PRViewCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isLogged
	^ false! !

!PRViewCommand methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isView
	^ true! !

PRObject subclass: #PRContext
	instanceVariableNames: 'kernel enumerator structure command timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

!PRContext commentStamp: 'lr 6/1/2006 21:12' prior: 0!
I am the context in which a user is browsing the system. I hold all the information any part of Pier might be interested in: the currently used kernel, the structure that is currently displayed, the command that is being executed and the user currently logged in.

I am an immutable object. Users should never try to modify me. Instead use the modification methods that return a copy of myself.!

!PRContext class methodsFor: 'accessing-description' stamp: 'lr 10/25/2006 17:35'!
descriptionStructure
	^ PRStructureDescription accessor: (MASelectorAccessor read: #structure write: #setStructure:) label: 'Structure' priority: 20! !

!PRContext class methodsFor: 'accessing-description' stamp: 'lr 10/25/2006 17:34'!
descriptionTimestamp
	^ MATimeStampDescription accessor: (MASelectorAccessor read: #timestamp write: #setTimestamp:) label: 'Timestamp' priority: 10! !

!PRContext class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRContext class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
kernel: aKernel
	^ self kernel: aKernel structure: aKernel root! !

!PRContext class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
kernel: aKernel structure: aStructure
	^ self kernel: aKernel structure: aStructure command: aStructure viewCommandClass new! !

!PRContext class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
kernel: aKernel structure: aStructure command: aCommand
	^ self new
		setKernel: aKernel;
		setStructure: aStructure;
		setCommand: aCommand;
		yourself! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/10/2006 15:02'!
command
	"Answer the active command of this context."

	^ command! !

!PRContext methodsFor: 'navigation' stamp: 'lr 5/29/2006 10:12'!
command: aCommand
	"Create a copy of the current context with the current command replaced by <code>aCommand</code>."

	^ self copy
		setCommand: aCommand;
		yourself! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 5/27/2006 17:28'!
commands
	"Answer a list of possible commands, dispatching through the command class."

	^ PRCommand withAllConcreteClasses
		select: [ :each | each isValidIn: self ]! !

!PRContext methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:04'!
enumerator
	"Answer a default structure enumerator for the current context."

	^ enumerator! !

!PRContext methodsFor: 'enumerating' stamp: 'lr 5/29/2006 10:12'!
enumerator: aStructure
	"Answer an enumerator on <code>aStructure</code>."

	^ self enumerator structure: aStructure! !

!PRContext methodsFor: 'testing' stamp: 'lr 5/28/2006 17:05'!
isValid
	"Answer <code>true</code> if the receiver is a valid context."

	^ self isValidCommand: self command class! !

!PRContext methodsFor: 'testing' stamp: 'lr 5/28/2006 17:05'!
isValidCommand: aCommandClass
	"Answer <code>true</code> if the receiver is a valid context with the current command replaced by <code>aCommandClass</code>."

	^ aCommandClass isValidIn: self! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/10/2006 15:01'!
kernel
	"Answer the underlying kernel of this context."

	^ kernel! !

!PRContext methodsFor: 'copying' stamp: 'lr 4/10/2006 15:17'!
postCopy
	super postCopy.
	self setEnumerator: self enumerator copy.
	self setTimestamp: nil! !

!PRContext methodsFor: 'printing' stamp: 'lr 3/9/2006 11:29'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' stucture: '; print: self structure title.
	aStream nextPutAll: ' command: '; print: self command class label! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 3/9/2006 11:29'!
root
	"Answer the current root node of the structure-tree."

	^ self kernel root! !

!PRContext methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setCommand: aCommand
	command := aCommand.
	command setContext: self! !

!PRContext methodsFor: 'initialization' stamp: 'lr 4/10/2006 15:00'!
setEnumerator: aVisitor
	enumerator := aVisitor! !

!PRContext methodsFor: 'initialization' stamp: 'lr 4/10/2006 15:13'!
setKernel: aKernel
	kernel := aKernel.
	self setEnumerator: (PRChildrenVisitor on: self root)! !

!PRContext methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setStructure: aStructure
	structure := aStructure! !

!PRContext methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setTimestamp: aTimestamp
	timestamp := aTimestamp! !

!PRContext methodsFor: 'accessing' stamp: 'lr 4/10/2006 15:02'!
structure
	"Answer the currently browsed structure of this context."

	^ structure! !

!PRContext methodsFor: 'navigation' stamp: 'lr 5/29/2006 10:12'!
structure: aStructure
	"Create a copy of the current context with the current structure replaced by <code>aStructure</code> and the current command replaced by the default view."

	^ self structure: aStructure command: aStructure viewCommandClass new! !

!PRContext methodsFor: 'navigation' stamp: 'lr 5/29/2006 10:13'!
structure: aStructure command: aCommand
	"Create a copy of the current context with the current structure replaced by <code>aStructure</code> and the current command by <code>aCommand</code>."

	^ self copy
		setStructure: aStructure;
		setCommand: aCommand;
		yourself! !

!PRContext methodsFor: 'accessing-conveniance' stamp: 'lr 6/2/2006 00:21'!
timestamp
	"Answer the timestamp when this context was used to execute its command, <code>nil</code> if never executed."

	^ timestamp! !

PRObject subclass: #PRDecorated
	instanceVariableNames: 'decorations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRDecorated commentStamp: 'lr 5/28/2006 17:43' prior: 0!
I am an abstract decorated object. My decorations are subclasses of *PRDecoration*. I provide all the tools to add, remove, query and visit my decorations.!

!PRDecorated methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitDecorated: self! !

!PRDecorated methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
acceptDecorated: aVisitor
	self
		decorationsDo: [ :each | aVisitor visit: each ]
		ownerDo: [ :each | super acceptDecorated: aVisitor ]! !

!PRDecorated methodsFor: 'adding' stamp: 'lr 5/28/2006 17:37'!
addDecoration: aDecoration
	"Add <code>aDecoration</code> to the receiver. This message ensures that <code>aDecoration</code> is only added once and that the decorations remain properly sorted."

	^ self
		addDecoration: aDecoration
		ifPresent: [ :value | self error: 'Decoration is already part of receiver.' ]! !

!PRDecorated methodsFor: 'adding' stamp: 'lr 5/28/2006 17:38'!
addDecoration: aDecoration ifPresent: aBlock
	"Add <code>aDecoration</code> to the receiver. This message ensures that the decorations remain properly sorted and that there are no duplicates. In case <code>aDecoration</code> is already within the receiver, the existing decoration is passed into <code>aBlock</code>."

	| decoration |
	decoration := self decorations
		detect: [ :each | aDecoration = each ]
		ifNone: [ nil ].
	^ decoration isNil
		ifFalse: [ aBlock value: decoration ]
		ifTrue: [
			self setDecorations: (decorations
				copyWith: (aDecoration
					setDecorated: self;
					yourself)) sort.
			aDecoration ]! !

!PRDecorated methodsFor: 'querying' stamp: 'lr 5/28/2006 17:40'!
decorationOfClass: aClass
	"Answer the first decoration of <code>aClass</code>, raise an error if none could be found."

	^ self
		decorationOfClass: aClass
		ifAbsent: [ self error: 'Decoration not found.' ]! !

!PRDecorated methodsFor: 'querying' stamp: 'lr 5/28/2006 17:41'!
decorationOfClass: aClass ifAbsent: aBlock
	"Answer the first decoration of <code>aClass</code>, evaluate <code>aBlock<code> if none could be found."

	^ self decorations
		detect: [ :each | aClass = each species ]
		ifNone: aBlock! !

!PRDecorated methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:37'!
decorations
	"Answer the sorted decorations of the receiver."

	^ decorations! !

!PRDecorated methodsFor: 'enumerating' stamp: 'lr 5/28/2006 17:39'!
decorationsDo: aBlock
	"Evaluate <code>aBlock</code> in the right order with each of the receiver's decorations as the argument."

	self decorations do: aBlock! !

!PRDecorated methodsFor: 'enumerating' stamp: 'lr 5/28/2006 17:39'!
decorationsDo: aBlock ownerDo: anOwnerBlock
	"Evaluate <code>aBlock</code> and <code>anOwnerBlock</code> in the right order with each of the receiver's decorations and the receiver as the argument."

	self decorations do: [ :each |
		each priority negative
			ifTrue: [ aBlock value: each ] ].
	anOwnerBlock value: self.
	self decorations do: [ :each |
		each priority positive
			ifTrue: [ aBlock value: each ] ]! !

!PRDecorated methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	self setDecorations: #()! !

!PRDecorated methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self setDecorations: (self decorations collect: [ :each |
		each copy postCopyTo: self ])! !

!PRDecorated methodsFor: 'removing' stamp: 'lr 5/28/2006 17:40'!
removeDecoration: aDecoration
	"Remove <code>aDecoration</code> from the receiver, an error is raised if <code>aDecoration</code> is not part of the receiver."

	^ self
		removeDecoration: aDecoration
		ifAbsent: [ self error: 'Decoration is not part of receiver.' ]! !

!PRDecorated methodsFor: 'removing' stamp: 'lr 5/28/2006 17:40'!
removeDecoration: aDecoration ifAbsent: aBlock
	"Remove <code>aDecoration</code> from the receiver, <code>aBlock</code> is evaluated if <code>aDecoration</code> is not part of the receiver."

	| decoration |
	decoration := self decorations
		detect: [ :each | aDecoration = each ]
		ifNone: [ ^ aBlock value ].
	self setDecorations: (self decorations
		copyWithout: (decoration
			setDecorated: nil;
			yourself)).
	^ decoration! !

!PRDecorated methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setDecorations: anArray
	decorations := anArray! !

PRDecorated subclass: #PRStructure
	instanceVariableNames: 'parent name title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRStructure commentStamp: 'lr 5/28/2006 17:41' prior: 0!
I am an abstract structure, representing the model of a single page. I've got a name, that must be unique within the scope of my parent, and a title. A structure is identified with a path of structure names.!

PRStructure subclass: #PRFile
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRFile commentStamp: 'lr 6/2/2006 10:54' prior: 0!
I represent a data container for images, videos, sound, pdf or zip files. I reference an instance of *MAFileModel*. The mime-type is used to determine how the given file is be displayed. As an example images and videos are attempted to be inlined into the resulting output, whereas zip-files are referenced as a link to allow downloading.!

!PRFile class methodsFor: 'accessing-description' stamp: 'lr 5/24/2006 15:16'!
descriptionFile
	^ (MAFileDescription selector: #file label: 'File' priority: 200)
		beEditable;
		yourself! !

!PRFile class methodsFor: 'accessing-resources' stamp: 'lr 3/9/2006 11:30'!
icon
	"PRCompatibility compileFileNamed: 'icons/file.png' into: PRFile class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 199 73 68 65 84 120 218 98 252 255 255 63 3 8 92 188 248 0 194 192 1 206 156 185 206 176 248 165 59 227 249 217 54 12 92 18 26 12 207 143 207 3 139 3 4 16 11 178 34 125 125 5 56 251 215 175 255 12 127 254 252 99 248 242 229 27 3 19 19 19 212 148 157 255 15 220 63 198 40 97 22 3 87 7 16 64 44 184 108 100 102 102 100 248 255 159 9 72 51 49 64 29 201 96 110 174 205 48 119 238 246 255 140 140 255 24 97 234 0 2 136 9 151 1 11 22 108 103 96 100 100 0 27 0 243 194 201 147 87 193 236 150 180 88 184 119 1 2 8 171 11 128 182 192 217 16 231 255 99 240 242 178 98 248 248 241 43 195 167 79 95 25 46 95 190 3 151 7 8 32 172 46 72 78 246 132 123 131 17 232 12 16 253 229 203 119 134 239 223 127 128 217 200 0 32 128 152 240 185 0 230 141 191 127 255 51 252 254 253 151 129 133 133 25 136 81 29 13 16 64 88 189 144 148 228 9 212 0 137 133 79 159 190 48 252 252 249 135 129 157 157 21 24 152 44 64 195 254 161 168 5 8 32 12 3 64 33 14 194 32 91 127 254 252 9 102 179 178 50 131 229 254 253 251 15 246 18 50 0 8 32 12 47 128 228 255 252 249 207 176 108 217 78 136 13 64 103 131 98 98 207 158 83 96 26 196 71 6 0 1 132 97 192 63 160 11 23 47 222 193 16 26 234 196 176 110 221 65 176 141 91 182 28 133 7 42 58 0 8 32 12 3 254 254 197 12 19 63 63 91 168 235 24 49 188 0 16 64 24 6 128 66 59 60 220 153 97 245 234 125 12 33 33 142 96 91 55 109 58 12 150 219 190 253 56 134 225 0 1 196 130 233 133 191 224 128 3 105 6 101 52 80 192 129 92 240 231 207 95 48 31 20 51 200 0 32 128 152 176 57 31 228 74 152 83 97 249 128 145 17 123 146 7 8 32 22 228 236 10 194 164 2 128 0 3 0 237 195 170 115 175 167 116 71 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!PRFile class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRFile methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitFile: self! !

!PRFile methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
contents
	^ self file contents! !

!PRFile methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
file
	^ file! !

!PRFile methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
file: aFile
	file := aFile! !

!PRFile methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
filename
	^ self file filename! !

!PRFile methodsFor: 'initialization' stamp: 'lr 3/12/2006 00:57'!
initialize
	super initialize.
	self file: MAFileModel new! !

!PRFile methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
mimetype
	^ self file mimetype! !

!PRFile methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self file: self file copy! !

PRStructure subclass: #PRPage
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRPage commentStamp: 'lr 6/1/2006 21:13' prior: 0!
I am the most important class of the structure hierarchy. I reference a composite of documents modeling the contents of the page that the user entered using the Wiki syntax. When initializing the instance a default document will be created to make the user aware of the newly created page.
!

!PRPage class methodsFor: 'accessing-description' stamp: 'lr 5/24/2006 15:17'!
descriptionContents
	^ (MAMemoDescription selector: #contents label: 'Contents' priority: 200)
		default: String new;
		beEditable;
		yourself! !

!PRPage class methodsFor: 'accessing-resources' stamp: 'lr 3/9/2006 11:30'!
icon
	"PRCompatibility compileFileNamed: 'icons/page.png' into: PRPage class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 211 73 68 65 84 120 218 98 252 255 255 63 3 8 92 188 248 0 194 192 1 206 156 185 206 176 248 165 59 227 249 217 54 12 92 18 26 12 207 143 207 3 139 3 4 16 11 178 34 125 125 5 56 251 215 175 255 12 127 254 252 99 248 242 229 27 3 19 19 19 212 148 157 255 15 220 63 198 40 97 22 3 87 7 16 64 44 184 108 100 102 102 100 248 255 159 9 72 51 49 64 29 201 96 110 174 205 48 119 238 246 255 140 140 255 24 97 234 0 2 8 195 128 221 187 207 130 233 191 127 25 24 254 253 251 207 96 101 165 13 118 9 200 11 48 208 146 22 11 50 18 108 8 64 0 97 24 224 234 106 12 166 255 253 99 0 106 252 207 240 227 199 47 16 143 193 203 203 138 225 227 199 175 12 159 62 125 101 184 124 249 14 92 61 64 0 225 116 1 200 217 32 67 126 254 252 13 116 205 95 176 230 31 63 126 48 152 153 105 161 168 7 8 32 156 46 128 121 227 251 247 95 64 141 191 25 94 189 250 0 228 255 1 123 11 25 0 4 16 86 23 128 108 7 57 255 239 223 127 12 223 190 125 103 248 253 251 15 152 13 18 183 180 212 65 81 15 16 64 24 6 184 184 24 131 21 254 252 249 15 236 100 144 237 160 180 242 251 247 95 176 237 255 64 254 66 2 0 1 132 97 192 158 61 103 129 138 255 3 211 193 47 176 6 136 205 16 141 32 182 141 141 62 138 122 128 0 194 48 192 217 217 24 232 239 223 96 197 32 77 160 40 4 25 240 231 207 95 56 31 25 0 4 16 134 1 59 119 130 92 240 27 108 59 72 35 178 11 64 180 149 149 30 138 122 128 0 194 48 192 222 222 0 168 248 47 220 0 152 173 160 168 4 137 161 187 0 32 128 48 12 0 105 6 5 34 72 243 190 125 231 192 46 0 25 250 31 71 86 3 8 32 20 3 64 241 14 2 140 140 32 204 200 224 232 104 8 15 3 144 24 54 67 0 2 136 5 57 187 34 167 119 98 1 64 128 1 0 237 159 25 57 6 58 246 245 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!PRPage class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRPage methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitPage: self! !

!PRPage methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
contents
	^ self rendererClass write: self document! !

!PRPage methodsFor: 'accessing-dynamic' stamp: 'lr 10/30/2006 16:26'!
contents: aString
	self document: (self parserClass parse: (aString ifNil: [ String new ]))! !

!PRPage methodsFor: 'accessing-configuration' stamp: 'lr 5/28/2006 17:35'!
defaultDocument
	"Answer the default document of the receiver."

	^ PRDocument new
		add: (PRParagraph new
			add: (PRText with: 'Edit this page ...');
			yourself);
		yourself! !

!PRPage methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:35'!
document
	"Answer the document of the receiver."

	^ document! !

!PRPage methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
document: aDocument
	document := aDocument.
	document owner: self! !

!PRPage methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasDocument
	^ self document notNil! !

!PRPage methodsFor: 'initialize-release' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	self document: self defaultDocument! !

!PRPage methodsFor: 'accessing-configuration' stamp: 'lr 5/29/2006 09:28'!
parserClass
	"Answer the default document parser for the receiver."

	^ PRDocumentParser! !

!PRPage methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self document: self document copy! !

!PRPage methodsFor: 'accessing-configuration' stamp: 'lr 5/28/2006 17:36'!
rendererClass
	"Answer the default document writer for the receiver."

	^ PRDocumentWriter! !

!PRStructure class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
canBeChildOf: aStructureClass
	^ true! !

!PRStructure class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
canBeParentOf: aStructureClass
	^ true! !

!PRStructure class methodsFor: 'accessing-private' stamp: 'lr 3/9/2006 11:30'!
descriptionName
	^ (MAStringDescription selector: #name label: 'Name')
		beRequired;
		yourself! !

!PRStructure class methodsFor: 'accessing-private' stamp: 'lr 3/9/2006 11:30'!
descriptionParent
	^ (PRStructureDescription selector: #parent label: 'Parent')
		beReadonly;
		beHidden;
		yourself! !

!PRStructure class methodsFor: 'accessing-private' stamp: 'lr 3/9/2006 11:30'!
descriptionRoot
	^ (PRStructureDescription selector: #root label: 'Root')
		beReadonly;
		beHidden;
		yourself! !

!PRStructure class methodsFor: 'accessing-description' stamp: 'lr 5/24/2006 15:17'!
descriptionTitle
	^ (MAStringDescription selector: #title label: 'Title' priority: 100)
		beRequired;
		beEditable;
		yourself! !

!PRStructure class methodsFor: 'accessing-resources' stamp: 'lr 3/9/2006 11:30'!
icon
	"PRCompatibility compileFileNamed: 'icons/structure.png' into: PRStructure class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 37 73 68 65 84 120 218 98 252 255 255 63 3 12 28 191 252 252 150 152 32 151 212 191 127 255 126 194 196 254 1 241 207 223 12 12 95 190 253 230 184 123 239 193 241 55 175 94 196 50 179 176 62 231 224 17 96 152 53 161 145 1 32 128 88 24 144 128 16 31 187 160 146 52 31 55 144 201 13 19 3 25 255 5 104 220 211 87 95 25 52 212 149 157 95 240 243 108 188 125 235 110 8 208 226 71 32 121 128 0 98 66 54 224 31 3 38 96 4 41 2 170 98 98 100 98 224 102 101 96 112 177 210 52 213 214 209 220 10 20 87 5 185 30 32 128 152 24 136 0 172 204 64 39 113 177 49 188 253 252 141 225 220 245 199 64 87 49 233 176 113 112 111 255 207 240 223 0 32 128 136 50 128 17 104 29 23 59 51 131 136 160 0 195 251 15 191 24 94 189 249 204 192 196 202 161 252 247 207 159 104 128 0 98 33 198 0 102 160 1 204 64 87 176 0 9 94 62 78 6 54 14 118 134 95 127 89 24 254 255 251 207 2 16 64 68 25 240 11 24 11 239 62 253 100 248 244 229 59 208 59 44 12 44 156 64 111 253 99 1 57 237 63 64 0 17 52 224 235 47 160 230 207 191 25 126 254 250 195 192 206 206 202 192 194 194 2 142 25 166 63 140 96 175 1 4 16 11 33 205 95 127 128 188 192 204 192 201 198 202 240 155 233 31 195 159 191 127 129 54 51 49 252 7 233 6 2 128 0 194 105 192 239 255 144 52 192 202 10 114 41 80 3 3 72 233 31 160 94 70 112 212 254 254 7 49 0 32 128 112 26 240 31 26 112 255 128 137 227 63 48 174 88 88 24 25 254 3 5 25 129 113 207 8 180 29 102 16 64 0 97 141 70 144 205 240 20 206 8 118 49 3 72 57 200 37 204 64 205 76 64 54 51 35 68 43 64 0 225 52 0 57 37 66 146 232 127 48 227 223 255 255 40 106 1 2 8 197 11 76 200 201 151 17 226 13 80 50 6 198 28 80 43 35 208 59 44 12 255 88 254 0 213 49 131 99 1 4 0 2 8 197 128 223 176 120 7 217 5 180 232 15 16 255 253 15 241 14 136 13 12 66 134 191 12 172 16 23 2 117 50 177 176 49 2 4 16 138 1 139 22 44 157 184 117 227 74 105 14 14 174 223 184 188 4 230 253 7 165 74 54 142 7 183 47 157 6 8 48 0 76 143 160 230 112 21 24 41 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!PRStructure class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
named: aString
	^ self new
		name: aString;
		yourself! !

!PRStructure methodsFor: 'comparing' stamp: 'lr 8/24/2006 22:46'!
< aStructure
	^ self title < aStructure title! !

!PRStructure methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
accept: aVisitor
	aVisitor visitStructure: self! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 5/28/2006 17:16'!
addChild: aStructure
	"Add <code>aStructure</code> as child to the receiver."

	^ self childrenDecoration add: aStructure! !

!PRStructure methodsFor: 'testing' stamp: 'lr 5/28/2006 17:19'!
canBeChildOf: aStructure
	"Answer <code>true</code> if the receiver can be a child of <code>aStructure</code>."

	^ self class canBeChildOf: aStructure class! !

!PRStructure methodsFor: 'testing' stamp: 'lr 5/28/2006 17:19'!
canBeParentOf: aStructure
	"Answer <code>true</code> if the receiver can be a parent of <code>aStructure</code>."

	^ self class canBeParentOf: aStructure class! !

!PRStructure methodsFor: 'decorations' stamp: 'lr 9/25/2006 08:13'!
childrenDecoration
	"Answer a decoration with the children of the receiver. If no children exist, an empty children decoration is added to the receiver. Don't call this method directly to avoid empty children decorations."

	^ self
		decorationOfClass: self childrenDecorationClass
		ifAbsent: [ self addDecoration: self childrenDecorationClass new ]! !

!PRStructure methodsFor: 'decorations' stamp: 'lr 3/9/2006 11:30'!
childrenDecorationClass
	^ PRChildren! !

!PRStructure methodsFor: 'accessing-persistency' stamp: 'lr 5/28/2006 17:17'!
creationTimestamp
	"Answer the creation-timestamp or <code>nil</code>."

	self kernel persistency
		do: [ :each | ^ each timestamp ]
		for: self.
	^ nil! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
document
	^ PRDocument new
		add: (PRInternalLink new
			embedded: true; target: self;
			add: (PRText with: self title);
			yourself);
		yourself! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'lr 6/2/2006 09:20'!
editCommandClass
	"Answer an instance of the default edit command of the receiver."

	^ PREditCommand! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 3/9/2006 11:30'!
enumerator
	"Answer an enumerator on the children of the receiver."

	^ PRChildrenVisitor on: self! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 10/30/2006 20:15'!
fullTextSearch
	"Answer a visitor searching for text starting at the receiver."

	^ PRFullTextSearch on: self! !

!PRStructure methodsFor: 'testing' stamp: 'lr 5/28/2006 17:19'!
hasChildren
	"Answer <code>true</code> if the receiver has got children, they might not be visible however."

	self enumerator hidden; do: [ :each | ^ true ].
	^ false! !

!PRStructure methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasDocument
	^ false! !

!PRStructure methodsFor: 'testing' stamp: 'lr 6/2/2006 11:08'!
hasParent
	"Answer <code>true</code> if the receiver has got a parent. This is the negation of <code>#isRoot</code>."

	^ self parent notNil! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
icon
	"Return the raw data of an icon representing the type of the receiver."

	^ self class icon! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 10/30/2006 20:31'!
incomingReferences
	"Answer a visitor on incoming references to structures being sepcified (using <code>to:</code> and <code>toAll:</code>) to the visitor before starting. The search will take off from the receiver."
	
	^ PRIncomingReferences on: self! !

!PRStructure methodsFor: 'testing' stamp: 'lr 6/2/2006 11:09'!
isAllowedCommand: aCommandClass in: aContext
 	"Answer <code>true</code> if the receiver accepts <code>aCommandClass</code> as allowed in <code>aContext</code> on the receiver. If a command class is allowed is a security question and should therefore only depend on the permissions in the current context. The default implementation delegates the decision to the decorations of the receiver. Therefor this method should never be overridden by subclasses."

	^ self decorations allSatisfy: [ :each |
		each
			isAllowedCommand: aCommandClass
			in: aContext ]! !

!PRStructure methodsFor: 'testing' stamp: 'lr 5/28/2006 17:23'!
isAncestorOf: aStructure
	"Answer <code>true</code> if the receiver is an ancestor of <code>aStructure</code>."

	^ aStructure parents includes: self! !

!PRStructure methodsFor: 'testing' stamp: 'lr 6/2/2006 11:13'!
isApplyableCommand: aCommandClass in: aContext
 	"Answer <code>true</code> if the receiver accepts <code>aCommandClass</code> as applyable in <code>aContext</code> on the receiver. If a command class is applyable or not is a question of saneness and compatibility, not of security. This method should be overridden by subclasses who want to forbid some commands."

	^ self isKindOf: aCommandClass structureClass! !

!PRStructure methodsFor: 'testing' stamp: 'lr 5/28/2006 17:28'!
isRoot
	"Answer <code>true</code> if the receiver is the root of the Pier model. This is the negation of <code>#hasParent</code>."

	^ self parent isNil! !

!PRStructure methodsFor: 'testing' stamp: 'lr 5/28/2006 17:30'!
isValidCommand: aCommandClass in: aContext
 	"Answer <code>true</code> if the receiver accepts to execute <code>aCommandClass</code> in <code>aContext</code>. This message is the combination of <code>#isApplyableCommand:in:</code> and <code>#isAllowedCommand:in:</code>. It should not be overridden."

	^ (self isApplyableCommand: aCommandClass in: aContext)
		and: [ self isAllowedCommand: aCommandClass in: aContext ]! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
kernel
	"Answer the kernel of the receiver."

	^ self root in: [ :root |
		PRKernel instances
			detect: [ :each | each root = root ]
			ifNone: [ self error: self title , ' is not part of a kernel.' ] ]! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 6/2/2006 09:21'!
level
	"Answer the nesting level of the receiver."

	^ self parents size! !

!PRStructure methodsFor: 'accessing-persistency' stamp: 'lr 5/28/2006 17:17'!
modificationTimestamp
	"Answer the modification-timestamp or <code>nil</code>."

	self kernel persistency
		reverseDo: [ :each | ^ each timestamp ]
		for: self.
	^ nil! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name
	"Answer the name of the receiver. The name should be simple and only contain letters and numbers, since it is used as an identifier within restrictive protocols."

	^ name! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
name: aString
	name := aString! !

!PRStructure methodsFor: 'accessing-children' stamp: 'lr 10/30/2006 20:28'!
outgoingReferences
	"Answer a visitor on all outgoing references taking off at the reciver. The visited objects are instances of <code>*PRInternalLink*</code>."
	
	^ PROutgoingReferences on: self! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
parent
	"Answer the parent structure of the receiver."

	^ parent! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
parent: aStructure
	parent := aStructure! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 6/2/2006 09:22'!
parents
	"Answer an ordered collection of all the parents of the receiver up and including the receiver itself."

	^ self isRoot
		ifTrue: [ OrderedCollection with: self ]
		ifFalse: [
			self parent parents
				addLast: self;
				yourself ]! !

!PRStructure methodsFor: 'copying' stamp: 'lr 3/9/2006 11:30'!
postCopy
	super postCopy.
	self parent: nil! !

!PRStructure methodsFor: 'copying' stamp: 'lr 3/9/2006 11:30'!
postCopyTo: anObject
	self parent: anObject! !

!PRStructure methodsFor: 'printing' stamp: 'lr 3/9/2006 11:30'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name! !

!PRStructure methodsFor: 'actions' stamp: 'lr 6/2/2006 09:22'!
remove
	"Remove the receiver from the parent structure."

	self parent childrenDecoration remove: self! !

!PRStructure methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:30'!
root
	"Answer the root structure of the receiver."

	^ self isRoot
		ifTrue: [ self ]
		ifFalse: [ self parent root ]! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
title
	"Answer the title of the receiver, essentially the name but starting uppercase."

	^ title ifNil: [ title := self name capitalized ]! !

!PRStructure methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
title: aString
	title := aString! !

!PRStructure methodsFor: 'testing' stamp: 'lr 9/11/2006 10:56'!
validateCommand: aCommand
 	"Validates <code>Command</code> to be executed within the context of the reicever. Throw an exception if there is something wrong with the command."

	self decorations do: [ :each | each validateCommand: aCommand ]! !

!PRStructure methodsFor: 'accessing-commands' stamp: 'lr 6/2/2006 09:20'!
viewCommandClass
	"Answer the default view command of the receiver. Most likely you never need to change the default implementation."

	^ PRViewCommand! !

PRObject subclass: #PRDecoration
	instanceVariableNames: 'decorated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRDecoration commentStamp: 'lr 5/30/2006 19:16' prior: 0!
I am an abstract decoration to add new behaviour and data to structures. Every decoration knows its owner, a subclass of *PRDecorated*. Decorations are considered to be equal if they are of the same species, but subclasses might want to refine this behaviour to be able to add multiple instances of the same class.

Within the owner decorations are ordered according to their priority. Decorations with a negative priority are visited before the owner, decorations with a positive one after the owner.!

PRDecoration subclass: #PRChildren
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRChildren commentStamp: 'lr 5/28/2006 17:47' prior: 0!
I hold the children of the decorated object.!

!PRChildren class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRChildren methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitChildren: self! !

!PRChildren methodsFor: 'actions' stamp: 'lr 5/28/2006 17:49'!
add: aStructure
	"Add <code>aStructure</code> as a child to the receiver."

	(self isValidChild: aStructure)
		ifFalse: [ self error: 'Unable to add structure to ' , self decorated title , '.' ].
	self children
		at: aStructure name
		put: (aStructure
			parent: self decorated;
			yourself).
	self triggerStructureAdded: aStructure.
	^ aStructure! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 5/28/2006 17:49'!
at: aString
	"Answer the child structure with the name <code>aString</code>, raise an error if the child can't be found."

	^ self at: aString ifAbsent: [ self error: 'Child not found.' ]! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 5/28/2006 17:49'!
at: aString ifAbsent: aBlock
	"Answer the child structure with the name <code>aString</code>, evaluate <code>aBlock</code> if the child can't be found."

	^ self children at: aString ifAbsent: aBlock! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 3/9/2006 11:29'!
at: aString ifPresent: aBlock
	^ self children at: aString ifPresent: aBlock! !

!PRChildren methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
children
	^ children! !

!PRChildren methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:29'!
childrenCollection
	^ Dictionary new! !

!PRChildren methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
do: aBlock
	self children do: aBlock! !

!PRChildren methodsFor: 'enumerating' stamp: 'lr 8/24/2006 22:47'!
do: aBlock sorted: aSortBlock
	(self children values sort: aSortBlock)
		do: aBlock! !

!PRChildren methodsFor: 'accessing-children' stamp: 'lr 3/9/2006 11:29'!
includes: aString
	^ self children includesKey: aString! !

!PRChildren methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	self setChildren: self childrenCollection! !

!PRChildren methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEmpty
	^ children isEmpty! !

!PRChildren methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isValidChild: aStructure
	^ aStructure name notNil
		and: [ aStructure name notEmpty
		and: [ aStructure parent isNil
		and: [ (self includes: aStructure name) not
		and: [ (self decorated canBeParentOf: aStructure)
		and: [ (aStructure canBeChildOf: self decorated) ] ] ] ] ]! !

!PRChildren methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopyTo: anObject
	super postCopyTo: anObject.
	self setChildren: self children copy.
	self children keysAndValuesDo: [ :key :value |
		self children at: key put: (value copy
			postCopyTo: self decorated) ]! !

!PRChildren methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
priority
	^ 200! !

!PRChildren methodsFor: 'actions' stamp: 'lr 9/24/2006 19:24'!
remove: aStructure
	"Remove <code>aStructure</code> from the receiver."

	self children keysAndValuesDo: [ :key :value |
		aStructure = value ifTrue: [
			self children removeKey: key.
			self triggerStructureRemoved: value.
			self isEmpty ifTrue: [ self remove ].
			^ value
				parent: nil;
				yourself ] ].
	self error: 'Unable to remove structure from ' , self decorated title , '.'! !

!PRChildren methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setChildren: aCollection
	children := aCollection! !

!PRChildren methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:47'!
size
	"Answer the number of children of the receiver."

	^ self children size! !

!PRChildren methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
triggerStructureAdded: aStructure
	PRDecoration withAllConcreteClassesDo: [ :each | each onStructureAdded: aStructure ]! !

!PRChildren methodsFor: 'events' stamp: 'lr 3/9/2006 11:29'!
triggerStructureRemoved: aStructure
	PRDecoration withAllConcreteClassesDo: [ :each | each onStructureRemoved: aStructure ]! !

!PRDecoration class methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
onStructureAdded: aStructure
	"This event is called whenever a structure is added as a child to another structure."! !

!PRDecoration class methodsFor: 'events' stamp: 'lr 3/9/2006 11:30'!
onStructureRemoved: aStructure
	"This event is called whenever a structure is removed as a child from another structure."! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
<= aDecoration
	^ self priority <= aDecoration priority! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= aDecoration
	^ self species = aDecoration species! !

!PRDecoration methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitDecoration: self! !

!PRDecoration methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:45'!
decorated
	"Answer the owner of the receiver, the decorated object."

	^ decorated! !

!PRDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ self species hash! !

!PRDecoration methodsFor: 'testing' stamp: 'lr 5/29/2006 08:31'!
isAllowedCommand: aCommandClass in: aContext
 	"Answer <code>true</code> if the receiver allows one to execute <code>aCommandClass</code> in <code>aContext</code>. The default decoration is fine with all the commands, subclasses might restrict to a selected set of commands within a given context. This method might be overridden by decorations that want to control the security."

	^ true! !

!PRDecoration methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	self setDecorated: nil! !

!PRDecoration methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopyTo: anObject
	super postCopyTo: anObject.
	self setDecorated: anObject! !

!PRDecoration methodsFor: 'accessing' stamp: 'lr 5/29/2006 09:27'!
priority
	"The default priority returns a number that defines in witch order the visitors will traverse through decorated objects. Negative numbers are visited before the decorated objects, positive numbers afterwards."

	^ self subclassResponsibility! !

!PRDecoration methodsFor: 'utilities' stamp: 'lr 3/9/2006 11:29'!
remove
	self decorated notNil
		ifFalse: [ ^ self ].
	self decorated
		removeDecoration: self
		ifAbsent: [ ]! !

!PRDecoration methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setDecorated: aStructure
	decorated := aStructure! !

!PRDecoration methodsFor: 'testing' stamp: 'lr 9/11/2006 10:56'!
validateCommand: aCommand
 	"Validates <code>Command</code> to be executed within the context of the reicever."! !

PRDecoration subclass: #PRHider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Structure'!

!PRHider commentStamp: 'lr 5/28/2006 17:48' prior: 0!
I hide the decorated object.!

!PRHider class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRHider methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitHider: self! !

!PRHider methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
priority
	^ -400! !

PRDecoration subclass: #PRMockDecoration
	instanceVariableNames: 'priority'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Utilities'!

!PRMockDecoration class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRMockDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= aDecoration
	^ super = aDecoration
		and: [ self priority = aDecoration priority ]! !

!PRMockDecoration methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self priority hash! !

!PRMockDecoration methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
priority
	^ priority! !

!PRMockDecoration methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
priority: anInteger
	priority := anInteger! !

PRObject subclass: #PRDocumentItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentItem commentStamp: 'lr 5/28/2006 20:30' prior: 0!
I am an abstract superclass for the document hierarchy. My subclasses include all the basic elements to represent a document.!

PRDocumentItem subclass: #PRAnchor
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRAnchor commentStamp: 'lr 5/29/2006 09:30' prior: 0!
I am an anchor within a document. I am used as a reference point within a large document.!

!PRAnchor class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionName
	^ MAStringDescription selector: #name label: 'Name'! !

!PRAnchor class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRAnchor class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
with: aString
	^ self new
		name: aString;
		yourself! !

!PRAnchor methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self name = anObject name ]! !

!PRAnchor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitAnchor: self! !

!PRAnchor methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self name hash! !

!PRAnchor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name
	^ name! !

!PRAnchor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name: aString
	name := aString! !

PRDocumentItem subclass: #PRDocumentGroup
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentGroup commentStamp: 'lr 5/28/2006 20:33' prior: 0!
I am an abstract group of document items.!

PRDocumentGroup subclass: #PRDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocument commentStamp: 'lr 5/28/2006 21:06' prior: 0!
I am the root of a document composite.!

!PRDocument class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRDocument methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitDocument: self! !

!PRDocumentGroup class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionText
	^ (MANumberDescription selector: #size label: 'Size')
		beReadonly;
		yourself! !

!PRDocumentGroup class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
with: aDocumentItem
	^ self new
		add: aDocumentItem;
		yourself! !

!PRDocumentGroup class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
withAll: aCollection
	^ self new
		addAll: aCollection;
		yourself! !

!PRDocumentGroup methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self children = anObject children ]! !

!PRDocumentGroup methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitDocumentGroup: self! !

!PRDocumentGroup methodsFor: 'adding' stamp: 'lr 3/20/2006 19:06'!
add: aDocumentItem
	self setChildren: (self children copyWith: aDocumentItem)! !

!PRDocumentGroup methodsFor: 'adding' stamp: 'lr 3/20/2006 19:06'!
addAll: aCollection
	self setChildren: (self children copyWithAll: aCollection)! !

!PRDocumentGroup methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:32'!
children
	"Answer the children of the receiver."

	^ children! !

!PRDocumentGroup methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasChildren
	^ self children notEmpty! !

!PRDocumentGroup methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self children hash! !

!PRDocumentGroup methodsFor: 'initialization' stamp: 'lr 3/20/2006 19:06'!
initialize
	super initialize.
	self setChildren: Array new! !

!PRDocumentGroup methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
owner: anObject
	super owner: anObject.
	self children do: [ :each | each owner: anObject ]! !

!PRDocumentGroup methodsFor: 'copying' stamp: 'lr 3/20/2006 19:06'!
postCopy
	super postCopy.
	self setChildren: (self children collect: #copy)! !

!PRDocumentGroup methodsFor: 'initialization' stamp: 'lr 3/20/2006 19:06'!
setChildren: aCollection
	children := aCollection! !

!PRDocumentGroup methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
size
	^ self children size! !

!PRDocumentGroup methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
text
	^ String streamContents: [ :stream |
		self children do: [ :each |
			stream nextPutAll: each text ] ]! !

PRDocumentGroup subclass: #PRHeader
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRHeader commentStamp: 'lr 5/28/2006 20:34' prior: 0!
I represent a header within a document. My level is a natural number.!

!PRHeader class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionLevel
	^ MANumberDescription selector: #level label: 'Level'! !

!PRHeader class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRHeader class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
with: anItem level: anInteger
	^ (self with: anItem)
		level: anInteger;
		yourself! !

!PRHeader class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
withAll: aCollection level: anInteger
	^ (self withAll: aCollection)
		level: anInteger;
		yourself! !

!PRHeader methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self level = anObject level ]! !

!PRHeader methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitHeader: self! !

!PRHeader methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self level hash! !

!PRHeader methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
level
	^ level! !

!PRHeader methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
level: anInteger
	level := anInteger! !

PRDocumentGroup subclass: #PRLink
	instanceVariableNames: 'reference embedded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRLink commentStamp: 'lr 5/28/2006 21:02' prior: 0!
I am an abstract link built from an alias and a reference. The alias is the string representation that will be displayed to the user, whereas the reference is a string identifying the target. If there is no alias, the reference itself is displayed. Links can try to embed the referenced target into the containing document.

!!Examples
=*Reference*
=+Alias>Embedded Reference*!

PRLink subclass: #PRExternalLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRExternalLink commentStamp: 'lr 5/28/2006 20:41' prior: 0!
I am an abstract external link with an URL (Uniform Resource Locator) as reference.!

!PRExternalLink class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionUrl
	^ (MAStringDescription selector: #url label: 'Url')
		beReadonly! !

!PRExternalLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRExternalLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidReference: aString
	^ '*://*' match: aString! !

!PRExternalLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	^ 40! !

!PRExternalLink methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitExternalLink: self! !

!PRExternalLink methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:41'!
url
	"Answer the URL the receiver is pointing to."

	^ String streamContents: [ :stream |
		stream
			nextPutAll: self urlPrefix;
			nextPutAll: self urlEntry;
			nextPutAll: self urlPostfix ]! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlEntry
	^ self reference! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:43'!
urlPostfix
	^ ''! !

!PRExternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:43'!
urlPrefix
	^ ''! !

PRExternalLink subclass: #PRGoogleLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRGoogleLink class methodsFor: 'testing' stamp: 'lr 9/4/2006 11:32'!
isValidReference: aString
	^ 'google:*' match: aString! !

!PRGoogleLink class methodsFor: 'accessing' stamp: 'lr 9/4/2006 11:31'!
priority
	^ 20! !

!PRGoogleLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:42'!
title
	^ self urlEntry! !

!PRGoogleLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/4/2006 11:31'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRGoogleLink methodsFor: 'accessing-dynamic' stamp: 'lr 9/4/2006 11:30'!
urlPrefix
	^ 'http://www.google.com/search?q='! !

PRExternalLink subclass: #PRIsbnLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRIsbnLink commentStamp: 'lr 5/28/2006 20:46' prior: 0!
I am an external link pointing to an ISBN (International Standard Book Number).!

!PRIsbnLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidReference: aString
	^ 'isbn:*' match: aString! !

!PRIsbnLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	^ 20! !

!PRIsbnLink methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitIsbnLink: self! !

!PRIsbnLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:42'!
title
	^ 'ISBN ' , self urlEntry! !

!PRIsbnLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRIsbnLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlPrefix
	^ 'http://www.amazon.com/exec/obidos/ISBN='! !

PRExternalLink subclass: #PRMailLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRMailLink commentStamp: 'lr 6/2/2006 11:29' prior: 0!
I am an external link pointing to a mail address. I encode my URL to prevent spam bots collecting the address.!

!PRMailLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidReference: aString
	^ '*@*.*' match: aString! !

!PRMailLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	^ 10! !

!PRMailLink methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitMailLink: self! !

!PRMailLink methodsFor: 'accessing-dynamic' stamp: 'lr 5/24/2006 11:12'!
urlEntry
	^ String streamContents: [ :stream |
		super urlEntry do: [ :each |
			2 atRandom = 1
				ifTrue: [ stream nextPut: each ]
				ifFalse: [ stream nextPut: $%; nextPutAll: ((each asciiValue printStringBase: 16)
		padded: #left to: 2 with: $0) ] ] ]! !

!PRMailLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlPrefix
	^ 'mailto:'! !

PRExternalLink subclass: #PRRfcLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRRfcLink commentStamp: 'lr 5/28/2006 20:46' prior: 0!
I am an external link pointing to a RFC (Request for Comments) document.!

!PRRfcLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidReference: aString
	^ 'rfc:*' match: aString! !

!PRRfcLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	^ 30! !

!PRRfcLink methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitRfcLink: self! !

!PRRfcLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 12:06'!
title
	^ 'RFC ' , self urlEntry! !

!PRRfcLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlEntry
	^ super urlEntry copyAfter: $:! !

!PRRfcLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlPostfix
	^ '.html'! !

!PRRfcLink methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
urlPrefix
	^ 'http://www.faqs.org/rfcs/rfc'! !

PRLink subclass: #PRInternalLink
	instanceVariableNames: 'owner target anchor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRInternalLink commentStamp: 'lr 5/28/2006 20:48' prior: 0!
I am an internal link pointing to a structure within the current kernel. I reference my owning structure to be able to lookup the referenced structure. The referenced structure is cached in the instance variable <code>target</code>.!

!PRInternalLink class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionAnchor
	^ MAStringDescription selector: #anchor label: 'Anchor'! !

!PRInternalLink class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionTarget
	^ PRStructureDescription selector: #target label: 'Target'! !

!PRInternalLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRInternalLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidReference: aString
	^ true! !

!PRInternalLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	^ 50! !

!PRInternalLink class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
reference: aString
	| index |
	^ (index := aString indexOf: $@) isZero
		ifTrue: [ super reference: aString ]
		ifFalse: [
			self new
				reference: (aString copyFrom: 1 to: index - 1);
				anchor: (aString copyFrom: index + 1 to: aString size);
				yourself ]! !

!PRInternalLink methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self anchor = anObject anchor ]! !

!PRInternalLink methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitInternalLink: self! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:48'!
anchor
	"Answer an anchor string the receiver is pointing to."

	^ anchor! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
anchor: aString
	anchor := aString! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasAnchor
	^ self anchor notNil! !

!PRInternalLink methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: self anchor hash! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isBroken
	^ self target isNil! !

!PRInternalLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isInternal
	^ true! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
owner
	^ owner! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
owner: anObject
	super owner: (owner := anObject).
	self refresh! !

!PRInternalLink methodsFor: 'actions' stamp: 'lr 6/2/2006 00:21'!
refresh
	"This message will be sent by the structure whenever it is parsed and the references have to be set up. It simply starts a look-up in the owner using the reference-string. In case the reference is invalid the target will be set to <code>nil</code> and the receiver is in a broken-state."

	self target: (PRPathLookup
		start: self owner
		path: self reference
		onError: [ nil ])! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:48'!
target
	"Answer the referenced structure."

	(target isNil and: [ self hasOwner ])
		ifTrue: [ self refresh ].
	^ target! !

!PRInternalLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target: aStructure
	target := aStructure! !

!PRInternalLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:41'!
title
	^ self target isNil 
		ifTrue: [ super title ]
		ifFalse: [ self target title ]! !

!PRInternalLink methodsFor: 'actions' stamp: 'lr 6/2/2006 11:23'!
update
	"This method will be sent to all the internal-links whenever the owner is renamed or moved to a different location in the structure tree. It automatically adjusts the receivers state, so that the reference still points to the right location and doesn't get broken."

	self reference: (PRPathReference
		from: self owner
		to: self target)! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionAlias
	^ (MAStringDescription selector: #alias label: 'Alias')
		beReadonly;
		yourself! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionHasAlias
	^ (MABooleanDescription selector: #hasAlias label: 'Aliased')
		beReadonly;
		yourself! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionHasAnchor
	^ (MABooleanDescription selector: #hasAnchor label: 'Anchored')
		beReadonly;
		yourself! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionIsBroken
	^ (MABooleanDescription selector: #isBroken label: 'Broken')
		beReadonly;
		yourself! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionIsEmbedded
	^ MABooleanDescription selector: #isEmbedded label: 'Embedded'! !

!PRLink class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionReference
	^ MAStringDescription selector: #reference label: 'Reference'! !

!PRLink class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
fromString: aString
	| classes |
	classes := (self withAllConcreteClasses
		select: [ :each | each isValidReference: aString ])
		asSortedCollection: [ :a :b | a priority < b priority ].
	^ classes first reference: aString! !

!PRLink class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isValidReference: aString
	self subclassResponsibility! !

!PRLink class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
priority
	self subclassResponsibility! !

!PRLink class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
reference: aString
	^ self new
		reference: aString;
		yourself! !

!PRLink methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ super = anObject
		and: [ self reference = anObject reference ]
		and: [ self embedded = anObject embedded ]! !

!PRLink methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitLink: self! !

!PRLink methodsFor: 'accessing-dynamic' stamp: 'lr 5/28/2006 20:39'!
alias
	"Answer the alias of the receiver or an empty string if none."

	^ self text! !

!PRLink methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:38'!
embedded
	"Answer <code>true</code> if the reference should be embedded."

	^ embedded! !

!PRLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
embedded: aBoolean
	embedded := aBoolean! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasAlias
	^ self hasChildren! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasAnchor
	^ false! !

!PRLink methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ super hash bitXor: (self reference hash bitXor: self embedded hash)! !

!PRLink methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	self embedded: false! !

!PRLink methodsFor: 'testing' stamp: 'lr 5/28/2006 20:49'!
isBroken
	"Answer <code>true</code> if the receiver is broken."

	^ false! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isEmbedded
	^ self embedded! !

!PRLink methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
isInternal
	^ false! !

!PRLink methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:39'!
reference
	"Answer the reference of the receiver."

	^ reference! !

!PRLink methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
reference: aString
	reference := aString! !

!PRLink methodsFor: 'accessing-dynamic' stamp: 'lr 10/20/2006 11:40'!
title
	"Answer a title of the link, this is should never be nil."

	^ self reference! !

PRDocumentGroup subclass: #PRList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRList commentStamp: 'lr 5/28/2006 20:55' prior: 0!
I am an abstract list. My children are instances of *PRListItem*.!

!PRList methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitList: self! !

PRList subclass: #PROrderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PROrderedList commentStamp: 'lr 5/28/2006 20:53' prior: 0!
I am an ordered list. I am typically used for numbered items.!

!PROrderedList class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PROrderedList methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitOrderedList: self! !

PRList subclass: #PRUnorderedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRUnorderedList commentStamp: 'lr 5/28/2006 20:53' prior: 0!
I am an unordered list. I am typically used for unnumbered lists!

!PRUnorderedList class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRUnorderedList methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
accept: aVisitor
	aVisitor visitUnorderedList: self! !

PRDocumentGroup subclass: #PRListItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRListItem commentStamp: 'lr 6/2/2006 11:26' prior: 0!
I am a item within a *PRList*.!

!PRListItem class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRListItem methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitListItem: self! !

PRDocumentGroup subclass: #PRParagraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRParagraph commentStamp: 'lr 5/28/2006 20:54' prior: 0!
I am a paragraph of text.!

!PRParagraph class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRParagraph methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitParagraph: self! !

PRDocumentGroup subclass: #PRPreformatted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRPreformatted commentStamp: 'lr 5/28/2006 20:56' prior: 0!
I am preformatted text or source code. My children are instances of *PRText*.!

!PRPreformatted class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRPreformatted methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitPreformatted: self! !

PRDocumentGroup subclass: #PRTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTable commentStamp: 'lr 5/28/2006 20:56' prior: 0!
I am a table. My children are instances of *PRTableRow*.!

!PRTable class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionColumnCount
	^ (MANumberDescription selector: #columnCount label: 'Column Count')
		beReadonly;
		yourself! !

!PRTable class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionRowCount
	^ (MANumberDescription selector: #rowCount label: 'Row Count')
		beReadonly;
		yourself! !

!PRTable class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRTable methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
accept: aVisitor
	aVisitor visitTable: self! !

!PRTable methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
columnCount
	^ self children inject: 0 into: [ :max :row | max max: row columnCount ]! !

!PRTable methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
rowCount
	^ self children size! !

PRDocumentGroup subclass: #PRTableCell
	instanceVariableNames: 'align'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTableCell commentStamp: 'lr 5/28/2006 20:57' prior: 0!
I am a cell of a table.!

!PRTableCell class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionAlign
	^ (MASingleOptionDescription selector: #align label: 'Align')
		options: #( nil #left #center #right );
		yourself! !

!PRTableCell class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRTableCell methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
= anObject
	^ super = anObject
		and: [ self align = anObject align ]! !

!PRTableCell methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
accept: aVisitor
	aVisitor visitTableCell: self! !

!PRTableCell methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
align
	^ align! !

!PRTableCell methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
align: aSymbol
	align := aSymbol! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
beAlignedCenter
	self align: #center! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
beAlignedLeft
	self align: #left! !

!PRTableCell methodsFor: 'actions' stamp: 'lr 3/9/2006 11:30'!
beAlignedRight
	self align: #right! !

!PRTableCell methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
hash
	^ super hash bitXor: self align hash! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAligned
	^ self align notNil! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAlignedCenter
	^ self align = #center! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAlignedLeft
	^ self align = #left! !

!PRTableCell methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAlignedRight
	^ self align = #right! !

PRDocumentGroup subclass: #PRTableRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRTableRow commentStamp: 'lr 5/28/2006 20:56' prior: 0!
I am a row of a table. My children are instances of *PRTableCell*.!

!PRTableRow class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionColumnCount
	^ (MANumberDescription selector: #columnCount label: 'Column Count')
		beReadonly! !

!PRTableRow class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRTableRow methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
accept: aVisitor
	aVisitor visitTableRow: self! !

!PRTableRow methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
columnCount
	^ self children size! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionHasChildren
	^ (MABooleanDescription selector: #hasChildren label: 'Has Children')
		beReadonly;
		yourself! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionHasOwner
	^ (MABooleanDescription selector: #hasOwner label: 'Has Owner')
		beReadonly;
		yourself! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionOwner
	^ (PRStructureDescription selector: #owner label: 'Owner')
		beReadonly;
		yourself! !

!PRDocumentItem class methodsFor: 'accessing-description' stamp: 'lr 3/9/2006 11:30'!
descriptionText
	^ (MAStringDescription selector: #text label: 'Text')
		beReadonly;
		yourself! !

!PRDocumentItem methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
= anObject
	^ self species = anObject species! !

!PRDocumentItem methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitDocumentItem: self! !

!PRDocumentItem methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasChildren
	^ false! !

!PRDocumentItem methodsFor: 'testing' stamp: 'lr 3/9/2006 11:29'!
hasOwner
	^ self owner notNil! !

!PRDocumentItem methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:29'!
hash
	^ self species hash! !

!PRDocumentItem methodsFor: 'accessing' stamp: 'lr 6/2/2006 11:17'!
owner
	"Answer the object owning the receiver. The default implementation doesn't know about its owner and therefore always returns <code>nil</code>."

	^ nil! !

!PRDocumentItem methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:30'!
owner: anObject! !

!PRDocumentItem methodsFor: 'accessing-dynamic' stamp: 'lr 5/28/2006 20:31'!
text
	"Answer a string representation of the receiver."

	^ String new! !

PRDocumentItem subclass: #PRHorizontalRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRHorizontalRule commentStamp: 'lr 5/28/2006 20:57' prior: 0!
I am a horizontal rule.!

!PRHorizontalRule class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRHorizontalRule methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitHorizontalRule: self! !

PRDocumentItem subclass: #PRText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRText commentStamp: 'lr 5/28/2006 20:58' prior: 0!
I am a plain text. I am the most important leaf node of the document composite.!

!PRText class methodsFor: 'accessing-configuration' stamp: 'lr 3/9/2006 11:30'!
descriptionText
	^ MAStringDescription selector: #text label: 'Text'! !

!PRText class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRText class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
with: aString
	^ self new
		text: aString;
		yourself! !

!PRText methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
= anObject
	^ super = anObject
		and: [ self text = anObject text ]! !

!PRText methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
accept: aVisitor
	aVisitor visitText: self! !

!PRText methodsFor: 'comparing' stamp: 'lr 3/9/2006 11:30'!
hash
	^ super hash bitXor: self text hash! !

!PRText methodsFor: 'printing' stamp: 'lr 3/9/2006 11:30'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' text: '; print: self text! !

!PRText methodsFor: 'accessing' stamp: 'lr 5/28/2006 20:57'!
text
	"Answer the string the receiver is representing."

	^ text! !

!PRText methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
text: aString
	text := aString! !

PRObject subclass: #PRKernel
	instanceVariableNames: 'name root persistency mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

PRKernel class
	instanceVariableNames: 'Instances'!

!PRKernel commentStamp: 'lr 6/2/2006 10:33' prior: 0!
I am the kernel of Pier. Several instances of myself might exist at the same time, but they all exist independently and don't share any data. I know the root structure and the persistency strategy of the whole data-model. Moreover I prevent any concurrent modifications to the model by providing a global mutex.!

PRKernel class
	instanceVariableNames: 'Instances'!

!PRKernel class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
instanceNamed: aString
	^ self instances detect: [ :each | each name = aString ]! !

!PRKernel class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
instances
	^ Instances ifNil: [ Instances := Set new ]! !

!PRKernel class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRKernel class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
named: aString
	^ self instances add: (self new
		name: aString;
		yourself)! !

!PRKernel class methodsFor: 'private' stamp: 'lr 3/9/2006 11:30'!
reset
	"This method is for development and testing purpose only, you should not call it directly unless you want to loose your wiki-kernels."

	(PRCompatibility confirm: 'Are you sure to drop all kernel instances?')
		ifTrue: [ Instances := nil ]! !

!PRKernel methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
critical: aBlock
	^ self mutex critical: aBlock! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 9/25/2006 08:32'!
defaultInfo
	^ (PRPage named: 'information')
		addChild: self defaultInfoIntroduction;
		addChild: self defaultInfoSyntax;
		addChild: self defaultInfoLicense;
		contents: '-*Introduction>introduction*
-*Syntax>syntax*
-*License>license*';
		yourself! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:29'!
defaultInfoIntroduction
	^ (PRPage named: 'introduction')
		contents: 'The term <i>Wiki</i> usually means the collaborative software used to create, edit and manage hypertext pages on the web. A Wiki enables the users to author their documents using a simple markup language within their preferred web-browser.
Translated from the Hawaiian language <i>Wiki wiki</i> means <i>fast</i> and that is exactly what the collaborative editing process of a WikiWiki Web is all about: Everybody should be able to create and update pages, without the need of user-name and password to login. However there are wiki vandals around that abuse the general public access and make it necessary to protect the content with security mechanism.

!!Problem
There are more than 150 Wiki implementations available and most of them are open source. There are even a few implementations available written in different Smalltalk dialects, so why did we create a new one?
All the implementations we had a look at have major flaws in extensibility: they don''t provide a proper object oriented-design that is covered by unit tests. Moreover they all keep the content of the pages within strings, which makes it painful to render and search the wiki. These wikis haven''t been designed for extensibility!!
The existing Smalltalk wikis are old and it seems that the developers don''t want to touch their running systems. Both, WikiWorks and SqueakWiki, have some of their domain code within external files, what makes the source hard to understand as it is not possible to use the editing and debugging facilities of the Smalltalk environment.

!!Solution
As stated, all the current wiki implementations have problems with extensibility and the design. Redoing the same mistakes is stupid, therefor we put together the following basic requirements and refinded them with the experience we made with the first version:
-<b>Object-Oriented Design:</b> Pier provides a fully object oriented domain model. As an example, the content of the pages is parsed and stored as a tree of different entities representing text, links, tables, lists, etc.
-<b>Extensibility:</b> Everything in Pier can be extended: page types, storage mechanism, actions, security mechanism, web-server, etc. Plug-ins can be shared within the community and loaded independently of each other into the system.
-<b>Open Source:</b> Pier is released under the MIT license which grants unrestricted rights to copy, modify, and redistribute as long as the original copyright and license terms are retained.
-<b>Test Suites:</b> Pier is heavily tested. There are more than 1000 unit tests included with the core of Pier. This makes it easy to change and verify the code and comes in extremely useful when porting Pier to other Smalltalk dialects or when writing extensions.';
		yourself! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:29'!
defaultInfoLicense
	^ (PRPage named: 'license')
		contents: '!!' , PRDistribution license;
		yourself! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:29'!
defaultInfoSyntax
	^ (PRPage named: 'syntax')
		contents: '!!Paragraphs
As carriage returns are preserved, simply add a newline to begin a new paragraph.

!!Headers
A line starting with <code>!!</code>s becomes a header line.

!!Horizontal Line
A line starting with <code>_</code> (underline) becomes a horizontal line. This is often used to separate topics.

!!Lists
Using lines starting with <code>#</code>s and <code>-</code>s, creates a list:
-A block of lines, where each line starts with <code>-</code> is transformed into a bulleted list, where each line is an entry.
-A block of lines, where each line starts with <code>#</code> is transformed into an ordered list, where each line is an entry.
-Lists can be nested. Thus, a line starting with <code>#-</code> is an element of a bulleted list that is part of an ordered list.

!!Tables
To create a table, start off the lines with <code>|</code> and separate the elements with <code>|</code>s. Each new line represents a new row of the table. The contents of cells can be aligned left, centered or aligned right by using <code>|{</code>, <code>||</code> or <code>|}</code> respectively.

!!Preformatted
To create a preformatted section, begin each line with <code>=</code>. A preformatted section uses equally spaced text so that spacing is preserved.

!!Links
To create a link, put it between <code>\*</code>s. All links have the following form <code>\*reference\*</code> or <code>\*alias>reference\*</code>, where the reference is depending on the kind of link that is created. The contents of some links, e.g. links pointing to image-files, can be embedded into the current document by using <code>+</code>s: <code>\+reference\+</code>. However not all types of links support embedding and will quietly ignore it.

!!!!Internal Links
If a structure with the given title exists in the wiki (e.g. <code>\*Path\*</code>), a link to that item shows up when the page is saved. In case the path points to an non-existing structure, the user will be offered the possibility to create a new one when clicking on the link. The path can be any absolute or relative  reference within the wiki.

!!!!External Links
-If the link is an URL (e.g. <code>\*http://www.lukas-renggli.ch\*</code>), a link to the external page shows up.
-If the link is an e-mail address (e.g. <code>\*renggli@iam.unibe.ch\*</code>), a link to mail that person shows up.
-If the link is an ISBN number (e.g. <code>\*isbn:3446202102\*</code>), a link to the given book shows up.
-If the link is an RFC number (e.g. <code>\*rfc:2616\*</code>), a link to the given RFC page shows up.

!!HTML
Use any HTML anywhere you want. Some useful HTML tags are:
-To make something <b>bold</b>, surround it by &lt;b&gt; and &lt;/b&gt;.
-To make something <i>italic</i>, surround it by &lt;i&gt; and &lt;/i&gt;.
-To make something <u>underlined</u>, surround it by &lt;u&gt; and &lt;/u&gt;.
-To make text appear in a different color (like <font color="green">green</font>, <font color="red">red</font>, <font color="blue">blue </font>, <font color="grey">grey</font>, <font color="yellow">yellow</font>, or <font color="orange">orange</font>), use &lt;font color="<i>a color</i>"&gt; <i> some text </i> &lt;/font&gt;.';
		yourself! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 3/9/2006 11:29'!
defaultName
	^ PRDistribution package! !

!PRKernel methodsFor: 'configuration' stamp: 'lr 9/25/2006 08:33'!
defaultRoot
	^ (PRPage named: 'pier')
		addChild: self defaultInfo;
		contents: 'Welcome to Pier (formerly called SmallWiki 2), the next generation of a fully extensible content management system implemented in Smalltalk. To read additional information, please consult the *information page>information*.';
		yourself! !

!PRKernel methodsFor: 'accessing-readonly' stamp: 'lr 5/29/2006 08:34'!
mutex
	"Return a mutex (an object that understands #critical:) to ensure that only one process is modifying the model at once. This is needed to make certain that the model remains in a consistent state. All write access must go through this mutex."

	^ mutex ifNil: [ mutex := Monitor new ]! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
name
	"Answer the name of the kernel."

	^ name ifNil: [ name := self defaultName ]! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:10'!
name: aString
	name := aString! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
persistency
	"Answer the persistency strategy of the receiver."

	^ persistency ifNil: [ persistency := PRNullPersistency new ]! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 9/27/2006 14:11'!
persistency: aPersistency
	persistency ifNotNil: [ persistency setKernel: nil ].
	persistency := aPersistency setKernel: self! !

!PRKernel methodsFor: 'printing' stamp: 'lr 3/9/2006 11:29'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' name: '; print: self name! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
root
	"Answer the root structure of the kernel."

	^ root ifNil: [ root := self defaultRoot ]! !

!PRKernel methodsFor: 'accessing' stamp: 'lr 5/28/2006 17:10'!
root: aStructure
	root := aStructure! !

!PRObject class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ true! !

!PRObject class methodsFor: 'instance creation' stamp: 'lr 5/5/2006 19:19'!
new
	"Create a new instance of this class and checks if it isn't abstract."

	self isAbstract ifTrue: [ self error: self name , ' is abstract.' ].
	^ self basicNew initialize! !

!PRObject class methodsFor: 'reflection' stamp: 'lr 3/9/2006 11:30'!
withAllConcreteClasses
	^ Array streamContents: [ :stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each ] ]! !

!PRObject class methodsFor: 'reflection' stamp: 'lr 3/9/2006 11:30'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [ :each |
		each isAbstract ifFalse: [
			aBlock value: each ] ]! !

!PRObject methodsFor: 'visiting' stamp: 'lr 5/28/2006 17:04'!
accept: aVisitor
	"Dispatch to <code>aVisitor</code> depending on the receiver."! !

!PRObject methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
errorPropertyNotFound: aSelector
	self error: 'Property ' , aSelector , ' not found.'! !

!PRObject methodsFor: 'testing' stamp: 'lr 5/28/2006 17:02'!
hasProperty: aKey
	"Test if the property <code>aKey</code> is defined within the receiver."

	^ self properties includesKey: aKey! !

!PRObject methodsFor: 'initialization' stamp: 'lr 5/5/2006 19:20'!
initialize! !

!PRObject methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopy
	super postCopy.
	properties := properties copy! !

!PRObject methodsFor: 'copying' stamp: 'lr 3/9/2006 11:29'!
postCopyTo: anObject! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 5/28/2006 17:01'!
properties
	"Answer the property dictionary of the receiver."

	^ properties ifNil: [ properties := Dictionary new ]! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 5/28/2006 17:01'!
propertyAt: aKey 
	"Answer the value of the property <code>aKey</code>, raises an error if the property doesn't exist."

	^ self propertyAt: aKey ifAbsent: [ self errorPropertyNotFound: aKey ]! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 5/28/2006 17:01'!
propertyAt: aKey ifAbsent: aBlock
	"Answer the value of the property <code>aKey</code>, or the result of <code>aBlock</code> if the property doesn't exist."

	^ self properties at: aKey ifAbsent: aBlock! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 5/28/2006 17:01'!
propertyAt: aKey ifAbsentPut: aBlock
	"Answer the value of the property <code>aKey</code>, or if the property doesn't exist adds and answers the result of evaluating <code>aBlock</code>."

	^ self properties at: aKey ifAbsentPut: aBlock! !

!PRObject methodsFor: 'accessing-properties' stamp: 'lr 5/28/2006 17:01'!
propertyAt: aKey put: aValue
	"Adds or replaces the property <code>aKey</code> with <code>aValue</code>."

	^ self properties at: aKey put: aValue! !

Object subclass: #PRPersistency
	instanceVariableNames: 'kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

PRPersistency subclass: #PRFilePersistency
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

!PRFilePersistency class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
on: aDirectory
	^ self new
		setDirectory: aDirectory;
		yourself! !

!PRFilePersistency methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
directory
	^ directory ifNil: [ directory := FileDirectory default ]! !

!PRFilePersistency methodsFor: 'enummerating' stamp: 'rjl 5/11/2006 22:35'!
do: aBlock 
	"There's a bug in deserialization that leaves commands with no fields or context, this causes an error which despite the ensure below, leaves the filestream open preventing any further use of that file, at which point fileNamed returns nil for all future calls. I'm returning self to prevent an error, the gc does eventually close the file and thigns start working again.  I think the bug is actually in the MABinaryWriter when it serializes the command"

	| fileStream |
	fileStream := self directory fileNamed: self logFilename.
	fileStream ifNil: [^self].
	
	[[fileStream atEnd] whileFalse: 
			[aBlock value: ((MABinaryReader read: fileStream)
						setKernel: self kernel;
						yourself)]] 
			ensure: [fileStream close]! !

!PRFilePersistency methodsFor: 'actions' stamp: 'rjl 5/11/2006 22:47'!
log: aContext
	| fileStream referenceStream |
	fileStream := self directory fileNamed: self logFilename.
	[ referenceStream := MACompatibility referenceStream: fileStream setToEnd.
		[ MABinaryWriter write: aContext description: aContext description to: referenceStream ]
			ensure: [ referenceStream close ] ]
		ensure: [ fileStream close ]! !

!PRFilePersistency methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
logFilename
	^ 'logs.obj'! !

!PRFilePersistency methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setDirectory: aDirectory
	directory := aDirectory! !

!PRFilePersistency methodsFor: 'actions' stamp: 'rjl 5/11/2006 22:47'!
snapshot
	| fileStream referenceStream |
	fileStream := self directory fileNamed: self snapshotFilename.
	[ referenceStream := MACompatibility referenceStream: fileStream setToEnd.
		[ referenceStream nextPut: self kernel ]
			ensure: [ referenceStream close ] ]
		ensure: [ fileStream close ]! !

!PRFilePersistency methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
snapshotFilename
	^ 'snapshots.obj'! !

PRPersistency subclass: #PRImagePersistency
	instanceVariableNames: 'duration process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

!PRImagePersistency methodsFor: 'enumerating' stamp: 'lr 9/27/2006 14:15'!
do: aBlock 
	"There is no history for now."! !

!PRImagePersistency methodsFor: 'accessing' stamp: 'lr 9/29/2006 08:39'!
duration
	^ duration! !

!PRImagePersistency methodsFor: 'accessing' stamp: 'lr 9/29/2006 08:39'!
duration: aDuration
	duration := aDuration! !

!PRImagePersistency methodsFor: 'initialization' stamp: 'lr 9/29/2006 08:39'!
initialize
	super initialize.
	duration := 1 hour! !

!PRImagePersistency methodsFor: 'actions' stamp: 'lr 10/25/2006 17:29'!
log: aContext
	| stream |
	(process isNil or: [ process isTerminated ])
		ifTrue: [ self start ].
	stream := FileDirectory default
		fileNamed: 'transactions.txt'.
	[ self log: aContext on: stream setToEnd ]
		ensure: [ stream close ]! !

!PRImagePersistency methodsFor: 'actions' stamp: 'lr 10/25/2006 17:31'!
log: aContext on: aStream
	aStream nextPutAll: ' == '; nextPutAll: aContext command class label; nextPutAll: ' == '; cr.
	aStream nextPutAll: ' -- context -- '; cr.
	aContext description do: [ :each |
		aStream 
			nextPutAll: each label; nextPutAll: ': '; 
			nextPutAll: (each toString: (aContext 
				readUsing: each)); cr ].
	aStream nextPutAll: ' -- command -- '; cr.
	aContext command description do: [ :each |
		aStream 
			nextPutAll: each label; nextPutAll: ': '; 
			nextPutAll: (each toString: (aContext command
				readUsing: each)); cr ].
	aStream cr; cr

! !

!PRImagePersistency methodsFor: 'private' stamp: 'lr 10/16/2006 11:33'!
process
	(Delay forDuration: self duration)
		wait.
	process := nil.
	self snapshot! !

!PRImagePersistency methodsFor: 'initialization' stamp: 'lr 10/16/2006 11:25'!
setKernel: aKernel
	super setKernel: aKernel.
	self stop! !

!PRImagePersistency methodsFor: 'actions' stamp: 'lr 10/25/2006 11:08'!
snapshot
	"Save the whole image for now."

	Smalltalk at: #UnixProcess ifPresent: [ :class | 
		(class thisOSProcess pid notNil 
			and: [ class respondsTo: #saveImageInBackgroundNicely ])
				ifTrue: [ ^ class saveImageInBackgroundNicely ] ].
	SmalltalkImage current snapshot: true andQuit: false! !

!PRImagePersistency methodsFor: 'actions-process' stamp: 'lr 10/25/2006 11:07'!
start
	process := [ self process ] 
		forkAt: 30 named: 'pier'! !

!PRImagePersistency methodsFor: 'actions-process' stamp: 'lr 10/25/2006 11:06'!
stop
	process := nil! !

PRPersistency subclass: #PRNullPersistency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Persistence'!

!PRNullPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
do: aBlock! !

!PRNullPersistency methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
log: aContext! !

!PRNullPersistency methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
snapshot! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
do: aBlock
	"Evaluates aBlock in chronological order for every item in the history of the kernel."

	self subclassResponsibility! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
do: aBlock for: aStructure
	"Evaluates aBlock in chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	self do: [ :each |
		each structure = aStructure
			ifTrue: [ aBlock value: each ] ]! !

!PRPersistency methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
history
	^ Array streamContents: [ :stream |
		self do: [ :each |
			stream nextPut: each ] ]! !

!PRPersistency methodsFor: 'conveniance' stamp: 'lr 3/9/2006 11:29'!
historyFor: aStructure
	^ Array streamContents: [ :stream |
		self
			do: [ :each | stream nextPut: each ]
			for: aStructure ]! !

!PRPersistency methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
kernel
	^ kernel! !

!PRPersistency methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
log: aContext
	"Log a aContext in the history of the kernel."

	self subclassResponsibility! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
reverseDo: aBlock
	"Evaluates aBlock in inverse chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	self history reverseDo: aBlock! !

!PRPersistency methodsFor: 'enumerating' stamp: 'lr 3/9/2006 11:29'!
reverseDo: aBlock for: aStructure
	"Evaluates aBlock in inverse chronological order for every item in the history of aStructure. Subclasses might want to override the default implementation for efficiency."

	(self historyFor: aStructure)
		reverseDo: aBlock! !

!PRPersistency methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setKernel: aKernel
	kernel := aKernel! !

!PRPersistency methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
snapshot
	"Create a snapshot of the kernel."

	self subclassResponsibility! !

Object subclass: #PRVisitor
	instanceVariableNames: 'escaper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRVisitor commentStamp: 'lr 6/2/2006 11:55' prior: 0!
I am an abstract visitor. I provide a default implementation of all visit messages that does not descend automatically into children of the visited graph. Subclasses should override all my messages in appropriate ways to visit the nodes they need.!

PRVisitor subclass: #PRDocumentWriter
	instanceVariableNames: 'stream nesting newline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentWriter commentStamp: 'lr 6/1/2006 21:17' prior: 0!
I am a visitor being able to transform a composite of document-items back into the original Wiki string.

!!Example
=| document |
=document := PRDocumentParser parse: '+Hello+ *World*'.
=string := PRDocumentWriter write: document.
=string inspect.!

!PRDocumentWriter class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
write: anObject
	^ self new write: anObject! !

!PRDocumentWriter class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
write: anObject to: aStream
	^ self new write: anObject to: aStream! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
contents
	^ stream contents! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
defaultStream
	^ String new writeStream! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
nest: aCharacter do: aBlock
	nesting := nesting copyWith: aCharacter.
	aBlock ensure: [ nesting := nesting allButLast ]! !

!PRDocumentWriter methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
newLine
	stream isEmpty
		ifFalse: [ stream nextPut: Character cr ].
	newline := true! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
nextPut: aCharacter
	stream nextPut: aCharacter.
	newline := false! !

!PRDocumentWriter methodsFor: 'streaming' stamp: 'lr 3/9/2006 11:29'!
nextPutAll: aString
	stream nextPutAll: aString.
	newline := false! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
start: anObject
	newline := true.
	nesting := String new.
	super start: anObject! !

!PRDocumentWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream
	^ stream! !

!PRDocumentWriter methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream: aStream
	stream := aStream! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitAnchor: anObject
	self newLine; nextPut: $@; nextPutAll: anObject name! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitHeader: anObject
	self newLine; nextPutAll: (String new: anObject level withAll: $!!).
	super visitHeader: anObject! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitHorizontalRule: anObject
	self newLine; nextPut: $_! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitLink: anObject
	anObject isEmbedded
		ifTrue: [ self nextPut: $+ ]
		ifFalse: [ self nextPut: $* ].
	anObject hasAlias ifTrue: [
		super visitLink: anObject.
		self nextPut: $> ].
	self nextPutAll: anObject reference.
	anObject hasAnchor ifTrue: [
		self nextPut: $@.
		self nextPutAll: anObject anchor ].
	anObject isEmbedded
		ifTrue: [ self nextPut: $+ ]
		ifFalse: [ self nextPut: $* ]! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitListItem: anObject
	newline ifFalse: [ self newLine ].
	self nextPutAll: nesting.
	super visitListItem: anObject! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitOrderedList: anObject
	self newLine.
	self nest: $# do: [ super visitOrderedList: anObject ]! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitParagraph: anObject
	self newLine.
	super visitParagraph: anObject! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitPreformatted: anObject
	anObject children
		do: [ :each | self newLine; nextPut: $=; nextPutAll: each text ]! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitTableCell: anObject
	self nextPut: $|.
	anObject isAligned ifTrue: [
		anObject isAlignedLeft ifTrue: [ self nextPut: ${ ].
		anObject isAlignedCenter ifTrue: [ self nextPut: $| ].
		anObject isAlignedRight ifTrue: [ self nextPut: $} ] ].
	super visitTableCell: anObject! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitTableRow: anObject
	self newLine.
	super visitTableRow: anObject! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 5/29/2006 09:31'!
visitText: anObject
	"Write out <code>anObject</code>'s text to the receivers output-stream and escape <code>$*</code> everywhere within. Also take care of the character escaping with <code>$=</code>, <code>$|</code>, <code>$!!</code>, <code>$#</code> and <code>$-</code> at the beginning of a line."

	anObject text do: [ :each |
		(each = $* or: each = $+ or: [ newline and: [ '=@|!!#-' includes: each ] ])
			ifTrue: [ self nextPut: $\ ].
		self nextPut: each ]! !

!PRDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:29'!
visitUnorderedList: anObject
	self newLine.
	self nest: $- do: [ super visitUnorderedList: anObject ]! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
write: anObject
	^ self write: anObject to: self defaultStream! !

!PRDocumentWriter methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
write: anObject to: aStream
	^ self stream: aStream; start: anObject; contents! !

PRVisitor subclass: #PRPath
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRPath methodsFor: 'accessing-configuration' stamp: 'lr 3/9/2006 11:29'!
parent
	^ '..'! !

!PRPath methodsFor: 'accessing-configuration' stamp: 'lr 3/9/2006 11:29'!
separator
	^ $/! !

!PRPath methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream
	^ stream! !

!PRPath methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
stream: aStream
	stream := aStream! !

PRPath subclass: #PRPathLookup
	instanceVariableNames: 'pathElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRPathLookup commentStamp: 'lr 5/28/2006 21:19' prior: 0!
I am a visitor used to look up a given path. I am able to lookup absolute and relative paths, following the syntax of unix operating systems.

!!Example
=(PRPathLookup
=	start: aStructure
=	path: '/Information/Copyright/..')
=		inspect!

PRPathLookup subclass: #PRIncompletePathLookup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRIncompletePathLookup class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
start: aStructure path: aString
	| visitor |
	visitor := self new
		stream: aString readStream;
		yourself.
	^ Association
		key: (visitor lookup: aStructure)
		value: visitor pathElement! !

!PRIncompletePathLookup methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
childNotFound: aStructure
	self readNext; escape: aStructure! !

!PRPathLookup class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
start: aStructure path: aString
	^ self new
		stream: aString readStream;
		lookup: aStructure! !

!PRPathLookup class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
start: aStructure path: aString onError: aBlock
	^ [ self start: aStructure path: aString ]
		on: Error
		do: [ :error | aBlock value ]! !

!PRPathLookup methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
childNotFound: aStructure
	self error: 'Invalid path ' , self stream contents! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
lookup: aStructure
	^ self withEscaper: [
		self stream peek = self separator
			ifTrue: [ self lookupRoot: aStructure ]
			ifFalse: [ self lookupStart: aStructure ].
		self childNotFound: aStructure ]! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
lookupRoot: aStructure
	self stream next.
	self visit: aStructure root! !

!PRPathLookup methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
lookupStart: aStructure
	self visit: aStructure! !

!PRPathLookup methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
pathElement
	^ pathElement! !

!PRPathLookup methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
pathElement: aString
	pathElement := aString! !

!PRPathLookup methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
readNext
	^ self stream upTo: self separator! !

!PRPathLookup methodsFor: 'visiting-decorations' stamp: 'lr 5/29/2006 08:35'!
visitChildren: anObject
	"This method does the lookup of the next structure by checking for a child with that name, since this value is hashed it can be done efficiently. If the lookup by name fails, it tries to match the title by iterating through the children. If this fails as well, the message <code>#childNotFound:</code> is sent."

	anObject
		at: self pathElement
		ifPresent: [ :value | ^ self visit: value ].
	anObject do: [ :each |
		self pathElement = each title
			ifTrue: [ ^ self visit: each ] ].
	self childNotFound: anObject decorated! !

!PRPathLookup methodsFor: 'visiting-structure' stamp: 'lr 3/9/2006 11:29'!
visitStructure: aStructure
	self stream atEnd
		ifTrue: [ self escape: aStructure ].
	self pathElement: self readNext.
	self pathElement = self parent ifTrue: [
		self visit: (aStructure isRoot
			ifTrue: [ aStructure ]
			ifFalse: [ aStructure parent ]) ].
	aStructure hasChildren
		ifFalse: [ self childNotFound: aStructure ]! !

PRPath subclass: #PRPathReference
	instanceVariableNames: 'source sourceParents target targetParents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRPathReference commentStamp: 'lr 5/28/2006 21:19' prior: 0!
I am a visitor used to print a short path from a structure to another one.

!!Example
=(PRPathReference
=	from: aFirstStructure
=	to: aSecondStructure)
=		inspect!

!PRPathReference class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
from: aFirstStructure to: aSecondStructure
	^ self new
		setSource: aFirstStructure;
		setTarget: aSecondStructure;
		reference! !

!PRPathReference class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
to: aStructure
	^ self from: aStructure root to: aStructure! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	stream := WriteStream on: String new! !

!PRPathReference methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
reference
	self source isRoot ifTrue: [ self writeSeparator ].
	self source = self target ifTrue: [ ^ self stream contents ].
	self sourceParents removeFirst = self targetParents removeFirst
		ifFalse: [ self error: 'Unable to reference external wiki.' ].
	[ self sourceParents notEmpty
		and: [ self targetParents notEmpty
		and: [ self sourceParents first = self targetParents first ] ] ] whileTrue: [
			self sourceParents removeFirst.
			self targetParents removeFirst ].
	self sourceParents reverseDo: [ :each |
		self writeParent; writeSeparator ].
	self targetParents do: [ :each |
		self visit: each; writeSeparator ].
	^ self stream skip: -1; contents! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setSource: aStructure
	source := aStructure! !

!PRPathReference methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:29'!
setTarget: aStructure
	target := aStructure! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
source
	^ source! !

!PRPathReference methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
sourceParents
	^ sourceParents ifNil: [ sourceParents := self source parents ]! !

!PRPathReference methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
target
	^ target! !

!PRPathReference methodsFor: 'accessing-dynamic' stamp: 'lr 3/9/2006 11:29'!
targetParents
	^ targetParents ifNil: [ targetParents := self target parents ]! !

!PRPathReference methodsFor: 'visiting-structure' stamp: 'lr 3/9/2006 11:29'!
visitStructure: aStructure
	stream nextPutAll: aStructure name! !

!PRPathReference methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
writeParent
	stream nextPutAll: self parent! !

!PRPathReference methodsFor: 'private' stamp: 'lr 3/9/2006 11:29'!
writeSeparator
	stream nextPut: self separator! !

PRVisitor subclass: #PRPluggableVisitor
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

PRPluggableVisitor subclass: #PREnumerableVisitor
	instanceVariableNames: 'structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

PREnumerableVisitor subclass: #PRChildrenVisitor
	instanceVariableNames: 'with all hidden sortBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRChildrenVisitor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
all
	"Tell the receiver to visit structures recursively."

	all := true! !

!PRChildrenVisitor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
all: aBoolean
	all := aBoolean! !

!PRChildrenVisitor methodsFor: 'actions' stamp: 'lr 10/30/2006 13:57'!
everything
	"Tell the receiver to visit everything."
	
	with := all := hidden := true! !

!PRChildrenVisitor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
hidden
	"Tell the receiver to visit hidden structures."

	hidden := true! !

!PRChildrenVisitor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
hidden: aBoolean
	hidden := aBoolean! !

!PRChildrenVisitor methodsFor: 'initialization' stamp: 'lr 8/24/2006 22:45'!
initialize
	super initialize.
	with := all := hidden := false.
	sortBlock := [ :a :b | a < b ]! !

!PRChildrenVisitor methodsFor: 'accessing' stamp: 'lr 8/24/2006 22:42'!
sortBlock: aBlock
	sortBlock := aBlock! !

!PRChildrenVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:29'!
start: anObject
	self withEscaper: [ super start: anObject ]! !

!PRChildrenVisitor methodsFor: 'copying' stamp: 'lr 10/30/2006 17:21'!
structure: aStructure
	^ self copy setStructure: aStructure! !

!PRChildrenVisitor methodsFor: 'visiting-decoration' stamp: 'lr 8/24/2006 22:44'!
visitChildren: anObject
	(all or: [ structure == anObject decorated ])
		ifFalse: [ ^ self ].
	anObject
		do: [ :each |
			self withEscaper: [
				self visit: each ] ]
		sorted: sortBlock! !

!PRChildrenVisitor methodsFor: 'visiting-decoration' stamp: 'lr 3/9/2006 11:29'!
visitHider: anObject
	hidden ifFalse: [ self escape: anObject ]! !

!PRChildrenVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/9/2006 11:29'!
visitStructure: aStructure
	(with or: [ structure ~~ aStructure ])
		ifTrue: [ block value: aStructure ]! !

!PRChildrenVisitor methodsFor: 'actions' stamp: 'lr 3/9/2006 11:29'!
with
	"Tell the receiver to visit the start structure as well."

	with := true! !

!PRChildrenVisitor methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:29'!
with: aBoolean
	with := aBoolean! !

!PREnumerableVisitor class methodsFor: 'instance creation' stamp: 'lr 10/30/2006 17:22'!
on: aStructure
	^ self new setStructure: aStructure! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 10/30/2006 17:13'!
collect: aBlock
	"Evaluate aBlock for every structure visited by the receiver and answer a collection of the results."

	^ Array streamContents: [ :stream |
		self do: [ :each |
			stream nextPut: (aBlock value: each) ] ]! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 10/30/2006 16:44'!
contents
	"Answer a collection of all elements that have been visited."

	^ self collect: #yourself
	! !

!PREnumerableVisitor methodsFor: 'enumerating' stamp: 'lr 10/30/2006 16:54'!
do: aBlock
	"Evaluate aBlock for every structure visited by the receiver."

	self setBlock: aBlock; start: structure! !

!PREnumerableVisitor methodsFor: 'initialization' stamp: 'lr 10/30/2006 16:45'!
setStructure: aStructure
	structure := aStructure! !

PREnumerableVisitor subclass: #PRFullTextSearch
	instanceVariableNames: 'subString caseSensitive lastStructure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRFullTextSearch commentStamp: 'lr 5/28/2006 21:26' prior: 0!
I am a pluggable visitor to quickly look for matching text in a subtree of structures.

!!Example
The following example opens an inspector on all structures with the text <code>foo</code>:
=(PRFullTextSearch 
=	from: aStructure
=	find: 'foo'
=	caseSensitive: false)
=		inspect!

!PRFullTextSearch class methodsFor: 'depreciated' stamp: 'lr 10/30/2006 17:25'!
from: aStructure find: aString caseSensitive: aBoolean
	^ (self on: aStructure)
		subString: aString;
		caseSensitive: aBoolean;
		contents! !

!PRFullTextSearch class methodsFor: 'depreciated' stamp: 'lr 10/30/2006 17:25'!
from: aStructure find: aString caseSensitive: aBoolean do: aBlock
	^ (self on: aStructure)
		subString: aString;
		caseSensitive: aBoolean;
		do: aBlock! !

!PRFullTextSearch methodsFor: 'accessing' stamp: 'lr 10/30/2006 20:10'!
caseSensitive: aBoolean
	"Set if the search text is case sensitive or not."
	
	caseSensitive := aBoolean! !

!PRFullTextSearch methodsFor: 'private' stamp: 'lr 10/30/2006 17:24'!
check: aString in: aStructure
	(lastStructure ~= aStructure and: [ aString includesSubstring: subString caseSensitive: caseSensitive ])
		ifTrue: [ block value: (lastStructure := aStructure) ]! !

!PRFullTextSearch methodsFor: 'initialization' stamp: 'lr 10/30/2006 17:25'!
initialize
	super initialize.
	subString := String new.
	caseSensitive := false! !

!PRFullTextSearch methodsFor: 'visiting' stamp: 'lr 10/30/2006 17:19'!
start: anObject
	lastStructure := nil.
	super start: anObject! !

!PRFullTextSearch methodsFor: 'accessing' stamp: 'lr 10/30/2006 20:10'!
subString: aString
	"Set the sub-string to be looked for."
	
	subString := aString! !

!PRFullTextSearch methodsFor: 'visiting-decoration' stamp: 'lr 3/9/2006 11:29'!
visitChildren: anObject
	self visitAll: anObject children! !

!PRFullTextSearch methodsFor: 'visiting-structure' stamp: 'lr 3/9/2006 11:29'!
visitPage: aStructure
	super visitPage: aStructure.
	self check: aStructure document text in: aStructure! !

!PRFullTextSearch methodsFor: 'visiting-structure' stamp: 'lr 10/30/2006 16:25'!
visitStructure: aStructure
	self check: aStructure title in: aStructure! !

PREnumerableVisitor subclass: #PRIncomingReferences
	instanceVariableNames: 'structures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PRIncomingReferences commentStamp: 'lr 10/30/2006 20:09' prior: 0!
I am a pluggable visitor to detect incoming references.

!!Example
The following example opens inspectors on all instances of *PRInternalLink* that point <code>aStructure</code>:
=aStructure incomingReferences 
=	from: aRootStructure
=	to: aStructure
=	do: [ :each | each inspect ]!

!PRIncomingReferences class methodsFor: 'depreciated' stamp: 'lr 10/30/2006 20:36'!
from: aStructure to: aCollectionOrStructure do: aBlock
	"Evaluates aBlock for every internal-link referencing the structures in aCollection starting at aStructure."

	^ (self on: aStructure)
		toAll: (aCollectionOrStructure isCollection
			ifTrue: [ aCollectionOrStructure ]
			ifFalse: [ Array with: aCollectionOrStructure ]);
		do: aBlock! !

!PRIncomingReferences methodsFor: 'initialization' stamp: 'lr 10/30/2006 20:11'!
initialize
	super initialize.
	structures := Set new! !

!PRIncomingReferences methodsFor: 'accessing' stamp: 'lr 10/30/2006 20:30'!
to: aStructure
	structures add: aStructure! !

!PRIncomingReferences methodsFor: 'accessing' stamp: 'lr 10/30/2006 20:30'!
toAll: aCollection
	structures addAll: aCollection! !

!PRIncomingReferences methodsFor: 'visiting-decoration' stamp: 'lr 3/9/2006 11:29'!
visitChildren: anObject
	self visitAll: anObject children! !

!PRIncomingReferences methodsFor: 'visiting-document' stamp: 'lr 10/30/2006 20:12'!
visitInternalLink: anObject
	(structures includes: anObject target)
		ifTrue: [ block value: anObject ]! !

!PRIncomingReferences methodsFor: 'visiting-structure' stamp: 'lr 3/9/2006 11:29'!
visitPage: anObject
	super visitPage: anObject.
	self visit: anObject document! !

PREnumerableVisitor subclass: #PROutgoingReferences
	instanceVariableNames: 'continue structures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Visitor'!

!PROutgoingReferences commentStamp: 'lr 10/30/2006 19:48' prior: 0!
I am a pluggable visitor visiting and probably following outgoing references. To do so I visit all the links of the page and evaluate my pluggable block for each of them. If the <code>continue</code> block answers <code>true</code> I follow the link and continue visiting the references of the target structure. The default behavior of the <code>continue</code> block is to follow the link only if it is embedded. I take care not to run into infinite recursion, so no structure will be visited more than once.

!!Examples
The following example answers a collection of referenced pages from <code>aStructure</code>:

=(aStructure outgoingReferences
=	collect: [ :each | each target ])
=		asSet
		
The following example answers a collection of all broken references that can be reached from <code>aStructure</code>:

=aStructure outgoingReferences
=	continue: [ :each | each isBroken not ];
= 	collect: [ :each | each isBroken ]!

!PROutgoingReferences class methodsFor: 'depreciated' stamp: 'lr 10/30/2006 17:41'!
start: aStructure do: aBlock
	^ (self on: aStructure) do: aBlock! !

!PROutgoingReferences methodsFor: 'accessing' stamp: 'lr 10/30/2006 20:11'!
continue: aBlock
	"A block to decide if the visitor should visit the structure referenced by the link passed into aBlock or not."
	
	continue := aBlock! !

!PROutgoingReferences methodsFor: 'initialization' stamp: 'lr 10/30/2006 19:42'!
initialize
	super initialize.
	continue := #isEmbedded! !

!PROutgoingReferences methodsFor: 'visiting' stamp: 'lr 10/30/2006 19:42'!
start: anObject
	structures := Set new.
	super start: anObject! !

!PROutgoingReferences methodsFor: 'visiting-document' stamp: 'lr 10/30/2006 19:43'!
visitInternalLink: anObject
	block value: anObject.
	(anObject target isNil or: [ structures includes: anObject target ])
		ifTrue: [ ^ self ].
	(continue value: anObject)
		ifTrue: [ self visit: anObject target ]! !

!PROutgoingReferences methodsFor: 'visiting-structure' stamp: 'lr 3/9/2006 11:29'!
visitPage: anObject
	super visitPage: anObject.
	self visit: anObject document! !

!PROutgoingReferences methodsFor: 'visiting-structure' stamp: 'lr 10/30/2006 19:43'!
visitStructure: aStructure
	structures add: aStructure! !

!PRPluggableVisitor methodsFor: 'initialization' stamp: 'lr 10/30/2006 16:53'!
setBlock: aBlock
	block := aBlock! !

!PRVisitor class methodsFor: 'building' stamp: 'lr 3/9/2006 11:30'!
buildVisitorHierarchyForClass: aClass selector: aSelectorBlock classified: aClassifiedBlock
	" self buildVisitorHierarchyForClass: PRObject selector: [ :class | 'visit' , (class name allButFirst: 3) , ':' ] classified: [ :class | 'visiting-' , (class category copyAfterLast: $-) asLowercase ] "

	aClass withAllSubclassesDo: [ :class |
		(class category beginsWith: 'Pier-Model') ifTrue: [
			(self selectors includes: (aSelectorBlock value: class)) ifFalse: [
				self
					compile: (String streamContents: [ :stream |
						stream nextPutAll: (aSelectorBlock value: class); nextPutAll: ' anObject'; cr.
						class = aClass ifFalse: [
							stream tab; nextPutAll: 'self '; nextPutAll: (aSelectorBlock value: class superclass); nextPutAll: ' anObject.' ] ])
					classified: (aClassifiedBlock value: class) ].
			class
				compile: (String streamContents: [ :stream |
					stream nextPutAll: 'accept: aVisitor'; cr.
					stream tab; nextPutAll: 'aVisitor '; nextPutAll: (aSelectorBlock value: class); nextPutAll: ' self.' ])
				classified: #visiting ] ]! !

!PRVisitor class methodsFor: 'instance creation' stamp: 'lr 3/9/2006 11:30'!
visit: anObject
	^ self new
		start: anObject;
		yourself! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 3/9/2006 11:30'!
escape: anObject
	escaper value: anObject! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 3/9/2006 11:30'!
hasEscaper
	^ escaper notNil! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
start: anObject
	self visit: anObject! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
visit: anObject
	anObject acceptDecorated: self! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
visitAll: aCollection
	aCollection do: [ :each | self visit: each ]! !

!PRVisitor methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
visitAll: aCollection separatedBy: aBlock
	aCollection do: [ :each | self visit: each ] separatedBy: aBlock! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitAnchor: anObject
	self visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/9/2006 11:30'!
visitChildren: anObject
	self visitDecoration: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 5/28/2006 17:03'!
visitDecorated: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 5/28/2006 17:03'!
visitDecoration: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitDocument: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitDocumentGroup: anObject
	self visitDocumentItem: anObject.
	self visitAll: anObject children! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitExternalLink: anObject
	self visitLink: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/9/2006 11:30'!
visitFile: anObject
	self visitStructure: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitHeader: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/9/2006 11:30'!
visitHider: anObject
	self visitDecoration: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitHorizontalRule: anObject
	self visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitInternalLink: anObject
	self visitLink: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitIsbnLink: anObject
	self visitExternalLink: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitLink: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitList: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitListItem: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitMailLink: anObject
	self visitExternalLink: anObject! !

!PRVisitor methodsFor: 'visiting-core' stamp: 'lr 3/9/2006 11:30'!
visitObject: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitOrderedList: anObject
	self visitList: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/9/2006 11:30'!
visitPage: anObject
	self visitStructure: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitParagraph: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitPreformatted: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitRfcLink: anObject
	self visitExternalLink: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitSmiley: anObject
	self visitText: anObject! !

!PRVisitor methodsFor: 'visiting-structure' stamp: 'lr 3/9/2006 11:30'!
visitStructure: anObject
	self visitDecorated: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitTable: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitTableCell: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitTableRow: anObject
	self visitDocumentGroup: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitText: anObject
	self visitDocumentItem: anObject! !

!PRVisitor methodsFor: 'visiting-document' stamp: 'lr 3/9/2006 11:30'!
visitUnorderedList: anObject
	self visitList: anObject! !

!PRVisitor methodsFor: 'escaping' stamp: 'lr 3/9/2006 11:30'!
withEscaper: aBlock
	| old |
	old := escaper.
	escaper := [ :value | ^ value ].
	^ aBlock ensure: [ escaper := old ]! !

!UndefinedObject methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	"do nothing"! !

!MAStringWriter methodsFor: '*pier-model-visiting-description' stamp: 'lr 3/9/2006 11:29'!
visitStructureDescription: aDescription
	stream nextPutAll: (PRPathReference to: self object)! !

Notification subclass: #PRCurrentContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Kernel'!

!PRCurrentContext commentStamp: 'lr 5/28/2006 17:06' prior: 0!
I am a dynamic variable. I answer the current context when being raised.!

!PRCurrentContext class methodsFor: 'utilities' stamp: 'lr 3/9/2006 11:30'!
use: anObject during: aBlock
	^ aBlock on: self do: [ :notification | notification resume: anObject ]! !

!PRCurrentContext class methodsFor: 'accessing' stamp: 'lr 10/30/2006 19:32'!
value
	"This is the read accessor of the current context."

	^ self signal ifNotNilDo: [ :result | result context ]! !

!PRCurrentContext class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
value: aContext
	"This is the write accessor of the current context."

	self signal context: aContext! !

SmaCCParser subclass: #PRDocumentParser
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentParser commentStamp: 'lr 6/1/2006 21:17' prior: 0!
I am a parser that builds a composite of document-items from a Wiki string. I don't raise errors for invalid input, but instead try to build a parse tree that is as close to the source as possible. I am automatically generated from the Smalltalk Compiler Compiler (SmaCC), do not edit my code manually.

!!Example
=(PRDocumentParser parse: '!!Foo bar')
=	explore!

!PRDocumentParser class methodsFor: 'generated-comments' stamp: 'lr 6/5/2006 11:01'!
parserDefinitionComment

	"# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

Document
	: DocumentItems { #createDocument };

DocumentItems
	: #nothing
	| DocumentItem
	| DocumentItems <newline> DocumentItem
	| DocumentItems BlankLine DocumentItem
	| DocumentItems <newline>
	| DocumentItems BlankLine ;

BlankLine
	: <blankline> { #addEmptyParagraph };

DocumentItem
	: HorizontalRule
	| Header
	| List
	| Anchor
	| Preformatted
	| Table
	| Paragraph ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

HorizontalRule
	: <horizontalRule> { #addHorizontalRule }
	| <horizontalRule> 'rule' Paragraph { self items last setChildren: (self createText: rule 
value) , self items last children };

Header
	: <header> 'header' ParagraphItems 'items' { self addHeader: items level: header value size } ;

List
	: <list> 'type' ParagraphItems 'items' { self addListItem: (PRListItem withAll: items) ofType: type value } ;

Anchor
	: <anchor> Line 'line' { self addAnchor: line } ;

Preformatted
	: <preformatted> Line 'line' { self addPreformatted: line } ;

Table
	: TableRow 'row' { self addTable: row } ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

TableRow
	: TableCells 'cells' { PRTableRow withAll: cells } ;
TableCells
	: TableCell 'cell' { OrderedCollection with: cell }
	| TableCells 'cells' TableCell 'cell' { cells add: cell; yourself } ;
TableCell
	: <tableleft> TableParagraphItems 'paragraph' { (PRTableCell withAll: paragraph) beAlignedLeft; yourself }
	| <tablecenter> TableParagraphItems 'paragraph' { (PRTableCell withAll: paragraph) beAlignedCenter; yourself }
	| <tableright> TableParagraphItems 'paragraph' { (PRTableCell withAll: paragraph) beAlignedRight; yourself }
	| <table> TableParagraphItems 'paragraph' { (PRTableCell withAll: paragraph) } ;
TableParagraphItems
	: { OrderedCollection new }
	| TableParagraphItems 'items' Text 'text' { self addAll: text to: items }
	| TableParagraphItems 'items' Link 'link' { self add: link to: items }
	| TableParagraphItems 'items' InternalTableParagraphText 'text' { self addAll: (self createText: text) to: items } ;
InternalTableParagraphText
	: <horizontalRule> { #stringValue: }
	| <header> { #stringValue: }
	| <list> { #stringValue: }
	| <nonLinkStart> 'text' { String with: text value last }
	| <anchor> { #stringValue: }
	| <preformatted> { #stringValue: }
	| <any> { #stringValue: } ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

Paragraph
	: ParagraphStart 'firstItem' ParagraphItems 'items' { self addParagraph: firstItem and: items } ;
ParagraphStart
	: Text { #liftFirstValue: }
	| <nonLinkStart> 'string' { self createText: (String with: string value last) }
	| Link
	| <any> 'char' { self createText: char value } ;
ParagraphItems
	: { OrderedCollection new }
	| ParagraphItems 'items' Text 'text' { self addAll: text to: items }
	| ParagraphItems 'items' Link 'link' { self add: link to: items }
	| ParagraphItems 'items' InternalTableParagraphText 'text' { self addAll: (self createText: text) to: items }
	| ParagraphItems 'items' <tableleft> 'text' { self add: (PRText with: text value) to: items }
	| ParagraphItems 'items' <tablecenter> 'text' { self add: (PRText with: text value) to: items }
	| ParagraphItems 'items' <tableright> 'text' { self add: (PRText with: text value) to: items }
	| ParagraphItems 'items' <table> 'text' { self add: (PRText with: text value) to: items } ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

Link
	: <link> 'link' { self createLink: link value } ;

Line
	: { '' }
	| Line 'line' InternalTableParagraphText 'text' { line , text }
	| Line 'line' <tableleft> 'text' { line , text value }
	| Line 'line' <tablecenter> 'text' { line , text value }
	| Line 'line' <tableright> 'text' { line , text value }
	| Line 'line' <table> 'text' { line , text value }
	| Line 'line' <text> 'text' { line , text value }
	| Line 'line' <link> 'link' { line , link value }  ;

Text
	: <text> 'text' { self createText: text value } ;"! !

!PRDocumentParser class methodsFor: 'generated-accessing' stamp: 'lr 6/5/2006 11:01'!
scannerClass
	^PRDocumentScanner! !

!PRDocumentParser class methodsFor: 'generated-starting states' stamp: 'lr 6/5/2006 11:01'!
startingStateForDocument
	^1! !

!PRDocumentParser methodsFor: 'private-utilities' stamp: 'lr 3/9/2006 11:29'!
add: anItem to: aCollection
	(aCollection notEmpty and: [ anItem class = PRText and: [ aCollection last class = PRText ] ])
		ifTrue: [ aCollection addAll: (self createText: aCollection removeLast text , anItem text) ]
		ifFalse: [ aCollection add: anItem ].
	^ aCollection! !

!PRDocumentParser methodsFor: 'private-utilities' stamp: 'lr 3/9/2006 11:29'!
addAll: aTextCollection to: aCollection
	aTextCollection do: [ :each |
		self add: each to: aCollection ].
	^ aCollection! !

!PRDocumentParser methodsFor: 'private-adding' stamp: 'lr 3/9/2006 11:29'!
addAnchor: aString
	self items add: (PRAnchor with: aString)! !

!PRDocumentParser methodsFor: 'private-adding' stamp: 'lr 3/9/2006 11:29'!
addEmptyParagraph
	self items add: PRParagraph new! !

!PRDocumentParser methodsFor: 'private-adding' stamp: 'lr 3/9/2006 11:29'!
addHeader: aCollection level: anInteger
	self items add: (PRHeader withAll: aCollection level: anInteger)! !

!PRDocumentParser methodsFor: 'private-adding' stamp: 'lr 3/9/2006 11:29'!
addHorizontalRule
	self items add: PRHorizontalRule new! !

!PRDocumentParser methodsFor: 'private-adding' stamp: 'lr 3/9/2006 11:29'!
addListItem: aListItem ofType: aString
	^ self addListItem: aListItem to: items ofType: aString! !

!PRDocumentParser methodsFor: 'private-adding' stamp: 'lr 3/9/2006 11:29'!
addListItem: aListItem to: aCollection ofType: aString
	| list type |
	type := self listTypeFor: aString.
	(aCollection isEmpty or: [ aCollection last class ~= type ])
		ifTrue: [ aCollection add: (type with: aListItem) ]
		ifFalse: [
			list := aCollection last.
			aString size > 1
				ifFalse: [ list add: aListItem ]
				ifTrue: [
					| newChildren listItem |
					listItem := list children last.
					newChildren := listItem children copy
						asOrderedCollection.
					self
						addListItem: aListItem
						to: newChildren
						ofType: (aString copyFrom: 2 to: aString size).
					newChildren size = listItem children size
						ifFalse: [ listItem add: newChildren last ] ] ]! !

!PRDocumentParser methodsFor: 'private-adding' stamp: 'lr 3/9/2006 11:29'!
addParagraph: aFirstCollection and: aSecondCollection
	| collection |
	collection := aFirstCollection asOrderedCollection.
	self addAll: aSecondCollection to: collection.
	self items add: (PRParagraph withAll: collection)! !

!PRDocumentParser methodsFor: 'private-adding' stamp: 'lr 3/9/2006 11:29'!
addPreformatted: aString
	| text |
	text := PRText with: aString.
	self lastDocumentClass = PRPreformatted
		ifTrue: [ self lastDocumentItem add: text ]
		ifFalse: [ self items add: (PRPreformatted with: text) ]! !

!PRDocumentParser methodsFor: 'private-adding' stamp: 'lr 3/9/2006 11:29'!
addTable: aTableRow
	self lastDocumentClass = PRTable
		ifTrue: [ self lastDocumentItem add: aTableRow ]
		ifFalse: [ self items add: (PRTable with: aTableRow) ]! !

!PRDocumentParser methodsFor: 'private-creating' stamp: 'lr 3/9/2006 11:29'!
createDocument
	^ PRDocument withAll: self items! !

!PRDocumentParser methodsFor: 'private-creating' stamp: 'lr 3/9/2006 11:29'!
createLink: aString
	| string index alias link |
	string := aString copyFrom: 2 to: aString size - 1.
	index := string indexOf: $> ifAbsent: [ 0 ].
	alias := nil.
	index isZero ifFalse: [
		alias := string copyFrom: 1 to: index - 1.
		string := string copyFrom: index + 1 to: string size ].
	link := (PRLink fromString: string)
		addAll: (self createText: alias);
		embedded: aString first = $+;
		yourself.
	^ link! !

!PRDocumentParser methodsFor: 'private-creating' stamp: 'lr 5/29/2006 09:14'!
createText: aString
	^ aString isEmptyOrNil
		ifTrue: [ Array new ]
		ifFalse: [ Array with: (PRText with: aString) ]! !

!PRDocumentParser methodsFor: 'initialize-release' stamp: 'lr 3/9/2006 11:29'!
initialize
	super initialize.
	items := OrderedCollection new! !

!PRDocumentParser methodsFor: 'private-accessing' stamp: 'lr 3/9/2006 11:29'!
items
	^ items! !

!PRDocumentParser methodsFor: 'private-accessing' stamp: 'lr 3/9/2006 11:29'!
lastDocumentClass
	^ items isEmpty
		ifTrue: [ nil ]
		ifFalse: [ items last class ]! !

!PRDocumentParser methodsFor: 'private-accessing' stamp: 'lr 3/9/2006 11:29'!
lastDocumentItem
	^ items isEmpty
		ifTrue: [ nil ]
		ifFalse: [ items last ]! !

!PRDocumentParser methodsFor: 'private-utilities' stamp: 'lr 3/9/2006 11:29'!
listTypeFor: aString
	^ aString first = $#
		ifTrue: [ PROrderedList ]
		ifFalse: [ PRUnorderedList ]! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForAnchor1: nodes 
	^ self addAnchor: (nodes at: 2)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForHeader1: nodes 
	^ self addHeader: (nodes at: 2) level: (nodes at: 1) value size! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForHorizontalRule2: nodes 
	^ self items last setChildren: (self createText: (nodes at: 1) value) 
				, self items last children! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForInternalTableParagraphText4: nodes 
	^ String with: (nodes at: 1) value last! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForLine1: nodes 
	^ ''! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForLine2: nodes 
	^ (nodes at: 1) , (nodes at: 2)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForLine3: nodes 
	^ (nodes at: 1) , (nodes at: 2) value! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForLine4: nodes 
	^ (nodes at: 1) , (nodes at: 2) value! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForLine5: nodes 
	^ (nodes at: 1) , (nodes at: 2) value! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForLine6: nodes 
	^ (nodes at: 1) , (nodes at: 2) value! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForLine7: nodes 
	^ (nodes at: 1) , (nodes at: 2) value! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForLine8: nodes 
	^ (nodes at: 1) , (nodes at: 2) value! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForLink1: nodes 
	^ self createLink: (nodes at: 1) value! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForList1: nodes 
	^ self addListItem: (PRListItem withAll: (nodes at: 2))
		ofType: (nodes at: 1) value! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForParagraph1: nodes 
	^ self addParagraph: (nodes at: 1) and: (nodes at: 2)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForParagraphItems1: nodes 
	^ OrderedCollection new! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForParagraphItems2: nodes 
	^ self addAll: (nodes at: 2) to: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForParagraphItems3: nodes 
	^ self add: (nodes at: 2) to: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForParagraphItems4: nodes 
	^ self addAll: (self createText: (nodes at: 2)) to: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForParagraphItems5: nodes 
	^ self add: (PRText with: (nodes at: 2) value) to: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForParagraphItems6: nodes 
	^ self add: (PRText with: (nodes at: 2) value) to: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForParagraphItems7: nodes 
	^ self add: (PRText with: (nodes at: 2) value) to: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForParagraphItems8: nodes 
	^ self add: (PRText with: (nodes at: 2) value) to: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForParagraphStart2: nodes 
	^ self createText: (String with: (nodes at: 1) value last)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForParagraphStart4: nodes 
	^ self createText: (nodes at: 1) value! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForPreformatted1: nodes 
	^ self addPreformatted: (nodes at: 2)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTable1: nodes 
	^ self addTable: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTableCell1: nodes 
	^ (PRTableCell withAll: (nodes at: 2))
		beAlignedLeft;
		yourself! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTableCell2: nodes 
	^ (PRTableCell withAll: (nodes at: 2))
		beAlignedCenter;
		yourself! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTableCell3: nodes 
	^ (PRTableCell withAll: (nodes at: 2))
		beAlignedRight;
		yourself! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTableCell4: nodes 
	^ PRTableCell withAll: (nodes at: 2)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTableCells1: nodes 
	^ OrderedCollection with: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTableCells2: nodes 
	^ (nodes at: 1)
		add: (nodes at: 2);
		yourself! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTableParagraphItems1: nodes 
	^ OrderedCollection new! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTableParagraphItems2: nodes 
	^ self addAll: (nodes at: 2) to: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTableParagraphItems3: nodes 
	^ self add: (nodes at: 2) to: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTableParagraphItems4: nodes 
	^ self addAll: (self createText: (nodes at: 2)) to: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForTableRow1: nodes 
	^ PRTableRow withAll: (nodes at: 1)! !

!PRDocumentParser methodsFor: 'generated-reduction actions' stamp: 'lr 6/5/2006 11:01'!
reduceActionForText1: nodes 
	^ self createText: (nodes at: 1) value! !

!PRDocumentParser methodsFor: 'generated-tables' stamp: 'lr 6/5/2006 11:01'!
reduceTable
	^#(
#(16 1 #reduceActionForTable1:)
#(17 0 #reduceActionForParagraphItems1:)
#(17 2 #reduceActionForParagraphItems2:)
#(17 2 #reduceActionForParagraphItems3:)
#(17 2 #reduceActionForParagraphItems4:)
#(17 2 #reduceActionForParagraphItems5:)
#(17 2 #reduceActionForParagraphItems6:)
#(17 2 #reduceActionForParagraphItems7:)
#(17 2 #reduceActionForParagraphItems8:)
#(18 2 #reduceActionForPreformatted1:)
#(19 2 #reduceActionForAnchor1:)
#(20 0 #reduceActionForLine1:)
#(20 2 #reduceActionForLine2:)
#(20 2 #reduceActionForLine3:)
#(20 2 #reduceActionForLine4:)
#(20 2 #reduceActionForLine5:)
#(20 2 #reduceActionForLine6:)
#(20 2 #reduceActionForLine7:)
#(20 2 #reduceActionForLine8:)
#(21 2 #reduceActionForList1:)
#(22 1 #reduceActionForTableRow1:)
#(23 1 #reduceActionForTableCells1:)
#(23 2 #reduceActionForTableCells2:)
#(24 2 #reduceActionForTableCell1:)
#(24 2 #reduceActionForTableCell2:)
#(24 2 #reduceActionForTableCell3:)
#(24 2 #reduceActionForTableCell4:)
#(25 2 #reduceActionForHeader1:)
#(26 0 #reduceActionForTableParagraphItems1:)
#(26 2 #reduceActionForTableParagraphItems2:)
#(26 2 #reduceActionForTableParagraphItems3:)
#(26 2 #reduceActionForTableParagraphItems4:)
#(27 1 #addHorizontalRule)
#(27 2 #reduceActionForHorizontalRule2:)
#(28 1 #addEmptyParagraph)
#(29 1 #reduceFor:)
#(29 1 #reduceFor:)
#(29 1 #reduceFor:)
#(29 1 #reduceFor:)
#(29 1 #reduceFor:)
#(29 1 #reduceFor:)
#(29 1 #reduceFor:)
#(30 1 #reduceActionForText1:)
#(31 1 #reduceActionForLink1:)
#(32 1 #stringValue:)
#(32 1 #stringValue:)
#(32 1 #stringValue:)
#(32 1 #reduceActionForInternalTableParagraphText4:)
#(32 1 #stringValue:)
#(32 1 #stringValue:)
#(32 1 #stringValue:)
#(33 1 #reduceFor:)
#(34 2 #reduceActionForParagraph1:)
#(35 1 #liftFirstValue:)
#(35 1 #reduceActionForParagraphStart2:)
#(35 1 #reduceFor:)
#(35 1 #reduceActionForParagraphStart4:)
#(36 1 #createDocument)
#(37 0 #reduceFor:)
#(37 1 #reduceFor:)
#(37 3 #reduceFor:)
#(37 3 #reduceFor:)
#(37 2 #reduceFor:)
#(37 2 #reduceFor:)
)! !

!PRDocumentParser methodsFor: 'generated-tables' stamp: 'lr 6/5/2006 11:01'!
transitionTable
	^#(
#(3 238 1 238 2 9 3 13 4 17 5 21 6 25 7 29 8 33 9 37 10 41 11 45 12 49 13 53 14 57 15 61 16 65 18 69 19 73 21 77 22 81 23 85 24 89 25 93 27 97 29 101 30 105 31 109 34 113 35 117 36 121 37 238 38)
#(3 134 1 134 2 45 12 49 13 53 14 57 15 101 30 105 31 125 34 113 35 134 38)
#(3 10 1 10 2 10 3 10 4 10 5 10 6 10 7 10 8 10 9 10 10 10 11 10 12 10 13 10 14 10 15 129 17 10 38)
#(3 10 1 10 2 10 3 10 4 10 5 10 6 10 7 10 8 10 9 10 10 10 11 10 12 10 13 10 14 10 15 133 17 10 38)
#(3 118 1 118 2 118 3 118 4 118 5 118 6 118 7 118 8 118 9 118 10 118 11 118 12 118 13 118 14 118 15 137 26 118 38)
#(3 118 1 118 2 118 3 118 4 118 5 118 6 118 7 118 8 118 9 118 10 118 11 118 12 118 13 118 14 118 15 141 26 118 38)
#(3 118 1 118 2 118 3 118 4 118 5 118 6 118 7 118 8 118 9 118 10 118 11 118 12 118 13 118 14 118 15 145 26 118 38)
#(3 118 1 118 2 118 3 118 4 118 5 118 6 118 7 118 8 118 9 118 10 118 11 118 12 118 13 118 14 118 15 149 26 118 38)
#(3 50 1 50 2 50 3 50 4 50 5 50 6 50 7 50 8 50 9 50 10 50 11 50 12 50 13 50 14 50 15 153 20 50 38)
#(3 50 1 50 2 50 3 50 4 50 5 50 6 50 7 50 8 50 9 50 10 50 11 50 12 50 13 50 14 50 15 157 20 50 38)
#(2 178 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 222 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 174 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 230 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 166 1 2 38)
#(2 162 1 2 38)
#(2 158 1 2 38)
#(2 154 1 2 38)
#(2 6 1 2 38)
#(3 86 1 86 2 21 6 25 7 29 8 33 9 161 24 86 38)
#(2 90 1 2 6 7 8 9 38)
#(2 150 1 2 38)
#(2 146 1 2 38)
#(2 242 1 2 38)
#(2 218 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 226 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 170 1 2 38)
#(3 10 1 10 2 10 3 10 4 10 5 10 6 10 7 10 8 10 9 10 10 10 11 10 12 10 13 10 14 10 15 165 17 10 38)
#(2 0 38)
#(3 169 1 173 2 177 28 234 38)
#(2 138 1 2 38)
#(3 114 1 114 2 181 3 185 4 189 5 193 6 197 7 201 8 205 9 209 10 213 11 45 12 217 13 53 14 221 15 225 30 229 31 233 32 114 38)
#(3 82 1 82 2 181 3 185 4 189 5 193 6 197 7 201 8 205 9 209 10 213 11 45 12 217 13 53 14 221 15 225 30 229 31 233 32 82 38)
#(3 98 1 98 2 181 3 185 4 189 5 98 6 98 7 98 8 98 9 209 10 213 11 45 12 217 13 53 14 221 15 237 30 241 31 245 32 98 38)
#(3 102 1 102 2 181 3 185 4 189 5 102 6 102 7 102 8 102 9 209 10 213 11 45 12 217 13 53 14 221 15 237 30 241 31 245 32 102 38)
#(3 106 1 106 2 181 3 185 4 189 5 106 6 106 7 106 8 106 9 209 10 213 11 45 12 217 13 53 14 221 15 237 30 241 31 245 32 106 38)
#(3 110 1 110 2 181 3 185 4 189 5 110 6 110 7 110 8 110 9 209 10 213 11 45 12 217 13 53 14 221 15 237 30 241 31 245 32 110 38)
#(3 42 1 42 2 181 3 185 4 189 5 249 6 253 7 257 8 261 9 209 10 213 11 265 12 217 13 269 14 221 15 273 32 42 38)
#(3 46 1 46 2 181 3 185 4 189 5 249 6 253 7 257 8 261 9 209 10 213 11 265 12 217 13 269 14 221 15 273 32 46 38)
#(2 94 1 2 6 7 8 9 38)
#(3 214 1 214 2 181 3 185 4 189 5 193 6 197 7 201 8 205 9 209 10 213 11 45 12 217 13 53 14 221 15 225 30 229 31 233 32 214 38)
#(3 254 1 254 2 9 3 13 4 17 5 21 6 25 7 29 8 33 9 37 10 41 11 45 12 49 13 53 14 57 15 61 16 65 18 69 19 73 21 77 22 81 23 85 24 89 25 93 27 277 29 101 30 105 31 109 34 113 35 254 38)
#(2 142 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(3 258 1 258 2 9 3 13 4 17 5 21 6 25 7 29 8 33 9 37 10 41 11 45 12 49 13 53 14 57 15 61 16 65 18 69 19 73 21 77 22 81 23 85 24 89 25 93 27 281 29 101 30 105 31 109 34 113 35 258 38)
#(2 182 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 186 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 190 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 26 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 30 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 34 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 38 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 202 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 198 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 194 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 206 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 14 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 18 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 22 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 122 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 126 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 130 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 58 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 62 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 66 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 70 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 78 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 74 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 54 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 246 1 2 38)
#(2 250 1 2 38)
)! !

!MAStringReader methodsFor: '*pier-model-visiting-description' stamp: 'lr 3/9/2006 11:29'!
visitStructureDescription: aDescription
	self object: (PRPathLookup
		start: self context structure
		path: self contents)! !

SmaCCScanner subclass: #PRDocumentScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Document'!

!PRDocumentScanner class methodsFor: 'generated-comments' stamp: 'lr 6/5/2006 11:01'!
scannerDefinitionComment

	"# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

<newline>			: \r \n | \n | \r ;
<blankline>			: <newline> <newline> ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

<horizontalRule>		: \_ [\ \t]* ;
<header>				: \!!+ ;
<list>				: [\#\-]+ ;
<tableleft>			: \| \{ ;
<tablecenter>		: \| \| ;
<tableright>			: \| \} ;
<table>				: \| ;
<preformatted>		: \= ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

<alias>				: \> ;
<anchor>			: \@ ;
<linkText>			: [^\*\+\>\@\r\n]* ;
<link>				: \* (<linkText> <alias>)? <linkText> (<anchor> <linkText>)? \*
					| \+ (<linkText> <alias>)? <linkText> (<anchor> <linkText>)? \+ ;
<nonLinkStart>		: \*\* | \+\+ | \\ [\*\+\=\@\!!\#\-\|] ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

<text>				: [^\r\n\|\*\+\!!\#\-\=\@\\]+ ;
<any> 				: . ;

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #"! !

!PRDocumentScanner methodsFor: 'generated-tokens' stamp: 'lr 6/5/2006 11:01'!
emptySymbolTokenId
	^38! !

!PRDocumentScanner methodsFor: 'generated-tokens' stamp: 'lr 6/5/2006 11:01'!
errorTokenId
	^39! !

!PRDocumentScanner methodsFor: 'generated-scanner' stamp: 'lr 6/5/2006 11:01'!
scan1
	
	[ self step.
	currentCharacter <= Character tab or: 
			[ (currentCharacter between: (Character value: 11) and: Character newPage) 
				or: 
					[ (currentCharacter between: (Character value: 14) and: $)) or: 
							[ (currentCharacter between: $, and: $=) 
								or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] ] ] 
			whileTrue.
	currentCharacter == $* ifTrue: [ ^ self recordAndReportMatch: #(12 ) ].
	currentCharacter == $@ ifTrue: [ ^ self scan2 ].
	^ self reportLastMatch! !

!PRDocumentScanner methodsFor: 'generated-scanner' stamp: 'lr 6/5/2006 11:01'!
scan2
	
	[ self step.
	currentCharacter <= Character tab or: 
			[ (currentCharacter between: (Character value: 11) and: Character newPage) 
				or: 
					[ (currentCharacter between: (Character value: 14) and: $)) or: 
							[ (currentCharacter between: $, and: $=) 
								or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] ] ] 
			whileTrue.
	currentCharacter == $* ifTrue: [ ^ self recordAndReportMatch: #(12 ) ].
	^ self reportLastMatch! !

!PRDocumentScanner methodsFor: 'generated-scanner' stamp: 'lr 6/5/2006 11:01'!
scan3
	
	[ self step.
	currentCharacter <= Character tab or: 
			[ (currentCharacter between: (Character value: 11) and: Character newPage) 
				or: 
					[ (currentCharacter between: (Character value: 14) and: $)) or: 
							[ (currentCharacter between: $, and: $=) 
								or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] ] ] 
			whileTrue.
	currentCharacter == $+ ifTrue: [ ^ self recordAndReportMatch: #(12 ) ].
	currentCharacter == $@ ifTrue: [ ^ self scan4 ].
	^ self reportLastMatch! !

!PRDocumentScanner methodsFor: 'generated-scanner' stamp: 'lr 6/5/2006 11:01'!
scan4
	
	[ self step.
	currentCharacter <= Character tab or: 
			[ (currentCharacter between: (Character value: 11) and: Character newPage) 
				or: 
					[ (currentCharacter between: (Character value: 14) and: $)) or: 
							[ (currentCharacter between: $, and: $=) 
								or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] ] ] 
			whileTrue.
	currentCharacter == $+ ifTrue: [ ^ self recordAndReportMatch: #(12 ) ].
	^ self reportLastMatch! !

!PRDocumentScanner methodsFor: 'generated-scanner' stamp: 'lr 6/5/2006 11:01'!
scan5
	self recordMatch: #(2 ).
	self step.
	currentCharacter == Character lf 
		ifTrue: [ ^ self recordAndReportMatch: #(2 ) ].
	^ self reportLastMatch! !

!PRDocumentScanner methodsFor: 'generated-scanner' stamp: 'lr 6/5/2006 11:01'!
scanForToken
	self step.
	(currentCharacter <= Character tab or: 
			[ (currentCharacter between: (Character value: 11) and: Character newPage) 
				or: 
					[ (currentCharacter between: (Character value: 14) and: Character space) 
						or: 
							[ currentCharacter == $" or: 
									[ (currentCharacter between: $$ and: $)) or: 
											[ currentCharacter == $, or: 
													[ (currentCharacter between: $. and: $<) or: 
															[ (currentCharacter between: $> and: $?) or: 
																	[ (currentCharacter between: $A and: $[) or: 
																			[ (currentCharacter between: $] and: $^) 
																				or: [ (currentCharacter between: $` and: ${) or: [ currentCharacter >= $} ] ] ] ] ] ] ] ] ] ] ]) 
		ifTrue: 
			[ self recordMatch: #(14 15 ).
			self step.
			(currentCharacter <= Character tab or: 
					[ (currentCharacter between: (Character value: 11) and: Character newPage) 
						or: 
							[ (currentCharacter between: (Character value: 14) and: Character space) 
								or: 
									[ currentCharacter == $" or: 
											[ (currentCharacter between: $$ and: $)) or: 
													[ currentCharacter == $, or: 
															[ (currentCharacter between: $. and: $<) or: 
																	[ (currentCharacter between: $> and: $?) or: 
																			[ (currentCharacter between: $A and: $[) 
																				or: [ (currentCharacter between: $] and: ${) or: [ currentCharacter >= $} ] ] ] ] ] ] ] ] ] ]) 
				ifTrue: 
					[ 
					[ self recordMatch: #(14 ).
					self step.
					currentCharacter <= Character tab or: 
							[ (currentCharacter between: (Character value: 11) and: Character newPage) 
								or: 
									[ (currentCharacter between: (Character value: 14) and: Character space) 
										or: 
											[ currentCharacter == $" or: 
													[ (currentCharacter between: $$ and: $)) or: 
															[ currentCharacter == $, or: 
																	[ (currentCharacter between: $. and: $<) or: 
																			[ (currentCharacter between: $> and: $?) or: 
																					[ (currentCharacter between: $A and: $[) 
																						or: [ (currentCharacter between: $] and: ${) or: [ currentCharacter >= $} ] ] ] ] ] ] ] ] ] ] ] 
							whileTrue.
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	(currentCharacter == $# or: [ currentCharacter == $- ]) 
		ifTrue: 
			[ self recordMatch: #(5 15 ).
			self step.
			(currentCharacter == $# or: [ currentCharacter == $- ]) 
				ifTrue: 
					[ 
					[ self recordMatch: #(5 ).
					self step.
					currentCharacter == $# or: [ currentCharacter == $- ] ] 
							whileTrue.
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter == Character lf 
		ifTrue: 
			[ self recordMatch: #(1 15 ).
			self step.
			currentCharacter == Character lf 
				ifTrue: [ ^ self recordAndReportMatch: #(2 ) ].
			currentCharacter == Character cr ifTrue: [ ^ self scan5 ].
			^ self reportLastMatch ].
	currentCharacter == Character cr 
		ifTrue: 
			[ self recordMatch: #(1 15 ).
			self step.
			currentCharacter == Character lf 
				ifTrue: 
					[ self recordMatch: #(1 2 ).
					self step.
					currentCharacter == Character lf 
						ifTrue: [ ^ self recordAndReportMatch: #(2 ) ].
					currentCharacter == Character cr ifTrue: [ ^ self scan5 ].
					^ self reportLastMatch ].
			currentCharacter == Character cr ifTrue: [ ^ self scan5 ].
			^ self reportLastMatch ].
	currentCharacter == $!! 
		ifTrue: 
			[ self recordMatch: #(4 15 ).
			self step.
			currentCharacter == $!! 
				ifTrue: 
					[ 
					[ self recordMatch: #(4 ).
					self step.
					currentCharacter == $!! ] 
							whileTrue.
					^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter == $* 
		ifTrue: 
			[ self recordMatch: #(15 ).
			self step.
			(currentCharacter <= Character tab or: 
					[ (currentCharacter between: (Character value: 11) and: Character newPage) 
						or: 
							[ (currentCharacter between: (Character value: 14) and: $)) or: 
									[ (currentCharacter between: $, and: $=) 
										or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] ]) 
				ifTrue: 
					[ 
					[ self step.
					currentCharacter <= Character tab or: 
							[ (currentCharacter between: (Character value: 11) and: Character newPage) 
								or: 
									[ (currentCharacter between: (Character value: 14) and: $)) or: 
											[ (currentCharacter between: $, and: $=) 
												or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] ] ] 
							whileTrue.
					currentCharacter == $* ifTrue: [ ^ self recordAndReportMatch: #(12 ) ].
					currentCharacter == $> ifTrue: [ ^ self scan1 ].
					currentCharacter == $@ ifTrue: [ ^ self scan2 ].
					^ self reportLastMatch ].
			currentCharacter == $* ifTrue: [ ^ self recordAndReportMatch: #(12 13 ) ].
			currentCharacter == $> ifTrue: [ ^ self scan1 ].
			currentCharacter == $@ ifTrue: [ ^ self scan2 ].
			^ self reportLastMatch ].
	currentCharacter == $+ 
		ifTrue: 
			[ self recordMatch: #(15 ).
			self step.
			(currentCharacter <= Character tab or: 
					[ (currentCharacter between: (Character value: 11) and: Character newPage) 
						or: 
							[ (currentCharacter between: (Character value: 14) and: $)) or: 
									[ (currentCharacter between: $, and: $=) 
										or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] ]) 
				ifTrue: 
					[ 
					[ self step.
					currentCharacter <= Character tab or: 
							[ (currentCharacter between: (Character value: 11) and: Character newPage) 
								or: 
									[ (currentCharacter between: (Character value: 14) and: $)) or: 
											[ (currentCharacter between: $, and: $=) 
												or: [ currentCharacter == $? or: [ currentCharacter >= $A ] ] ] ] ] ] 
							whileTrue.
					currentCharacter == $+ ifTrue: [ ^ self recordAndReportMatch: #(12 ) ].
					currentCharacter == $> ifTrue: [ ^ self scan3 ].
					currentCharacter == $@ ifTrue: [ ^ self scan4 ].
					^ self reportLastMatch ].
			currentCharacter == $+ ifTrue: [ ^ self recordAndReportMatch: #(12 13 ) ].
			currentCharacter == $> ifTrue: [ ^ self scan3 ].
			currentCharacter == $@ ifTrue: [ ^ self scan4 ].
			^ self reportLastMatch ].
	currentCharacter == $= ifTrue: [ ^ self recordAndReportMatch: #(10 15 ) ].
	currentCharacter == $@ ifTrue: [ ^ self recordAndReportMatch: #(11 15 ) ].
	currentCharacter == $\ 
		ifTrue: 
			[ self recordMatch: #(15 ).
			self step.
			(currentCharacter == $!! or: 
					[ currentCharacter == $# or: 
							[ (currentCharacter between: $* and: $+) or: 
									[ currentCharacter == $- or: 
											[ currentCharacter == $= 
												or: [ currentCharacter == $@ or: [ currentCharacter == $| ] ] ] ] ] ]) 
				ifTrue: [ ^ self recordAndReportMatch: #(13 ) ].
			^ self reportLastMatch ].
	currentCharacter == $_ 
		ifTrue: 
			[ self recordMatch: #(3 14 15 ).
			self step.
			(currentCharacter <= Character backspace or: 
					[ (currentCharacter between: (Character value: 11) and: Character newPage) 
						or: 
							[ (currentCharacter between: (Character value: 14) and: (Character value: 31)) 
								or: 
									[ currentCharacter == $" or: 
											[ (currentCharacter between: $$ and: $)) or: 
													[ currentCharacter == $, or: 
															[ (currentCharacter between: $. and: $<) or: 
																	[ (currentCharacter between: $> and: $?) or: 
																			[ (currentCharacter between: $A and: $[) 
																				or: [ (currentCharacter between: $] and: ${) or: [ currentCharacter >= $} ] ] ] ] ] ] ] ] ] ]) 
				ifTrue: 
					[ 
					[ self recordMatch: #(14 ).
					self step.
					currentCharacter <= Character tab or: 
							[ (currentCharacter between: (Character value: 11) and: Character newPage) 
								or: 
									[ (currentCharacter between: (Character value: 14) and: Character space) 
										or: 
											[ currentCharacter == $" or: 
													[ (currentCharacter between: $$ and: $)) or: 
															[ currentCharacter == $, or: 
																	[ (currentCharacter between: $. and: $<) or: 
																			[ (currentCharacter between: $> and: $?) or: 
																					[ (currentCharacter between: $A and: $[) 
																						or: [ (currentCharacter between: $] and: ${) or: [ currentCharacter >= $} ] ] ] ] ] ] ] ] ] ] ] 
							whileTrue.
					^ self reportLastMatch ].
			(currentCharacter == Character tab 
				or: [ currentCharacter == Character space ]) 
					ifTrue: 
						[ 
						[ self recordMatch: #(3 14 ).
						self step.
						(currentCharacter <= Character backspace or: 
								[ (currentCharacter between: (Character value: 11) and: Character newPage) 
									or: 
										[ (currentCharacter between: (Character value: 14) and: (Character value: 31)) 
											or: 
												[ currentCharacter == $" or: 
														[ (currentCharacter between: $$ and: $)) or: 
																[ currentCharacter == $, or: 
																		[ (currentCharacter between: $. and: $<) or: 
																				[ (currentCharacter between: $> and: $?) or: 
																						[ (currentCharacter between: $A and: $[) 
																							or: [ (currentCharacter between: $] and: ${) or: [ currentCharacter >= $} ] ] ] ] ] ] ] ] ] ]) 
							ifTrue: 
								[ 
								[ self recordMatch: #(14 ).
								self step.
								currentCharacter <= Character tab or: 
										[ (currentCharacter between: (Character value: 11) and: Character newPage) 
											or: 
												[ (currentCharacter between: (Character value: 14) and: Character space) 
													or: 
														[ currentCharacter == $" or: 
																[ (currentCharacter between: $$ and: $)) or: 
																		[ currentCharacter == $, or: 
																				[ (currentCharacter between: $. and: $<) or: 
																						[ (currentCharacter between: $> and: $?) or: 
																								[ (currentCharacter between: $A and: $[) 
																									or: [ (currentCharacter between: $] and: ${) or: [ currentCharacter >= $} ] ] ] ] ] ] ] ] ] ] ] 
										whileTrue.
								^ self reportLastMatch ].
						currentCharacter == Character tab 
							or: [ currentCharacter == Character space ] ] 
								whileTrue.
						^ self reportLastMatch ].
			^ self reportLastMatch ].
	currentCharacter == $| 
		ifTrue: 
			[ self recordMatch: #(9 15 ).
			self step.
			currentCharacter == ${ ifTrue: [ ^ self recordAndReportMatch: #(6 ) ].
			currentCharacter == $| ifTrue: [ ^ self recordAndReportMatch: #(7 ) ].
			currentCharacter == $} ifTrue: [ ^ self recordAndReportMatch: #(8 ) ].
			^ self reportLastMatch ].
	^ self reportLastMatch! !

!Collection methodsFor: '*pier-model' stamp: 'lr 3/9/2006 11:29'!
accept: aVisitor
	aVisitor visitAll: self! !

!MABinaryWriter methodsFor: '*pier-model-visiting-description' stamp: 'lr 3/9/2006 11:29'!
visitStructureDescription: aDescription
	self visitDescription: aDescription.
	stream nextPut: (PRPathReference to: self object)! !

MAElementDescription subclass: #PRStructureDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Magritte'!

!PRStructureDescription class methodsFor: 'testing' stamp: 'lr 3/9/2006 11:30'!
isAbstract
	^ false! !

!PRStructureDescription class methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
label
	^ 'Structure'! !

!PRStructureDescription methodsFor: 'visiting' stamp: 'lr 3/9/2006 11:30'!
acceptMagritte: aVisitor
	aVisitor visitStructureDescription: self! !

!PRStructureDescription methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
kind
	^ PRStructure! !

MAError subclass: #PRStructureError
	instanceVariableNames: 'structure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

PRStructureError subclass: #PRConflictingNameError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

!PRConflictingNameError class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
in: aStructure title: aString
	^ (self structure: aStructure)
		signal: aString printString , ' conflicts in ' , aStructure title printString! !

PRStructureError subclass: #PRInvalidNestingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Model-Exception'!

!PRInvalidNestingError class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
of: aChildStructure in: aParentStructure
	^ (self structure: aParentStructure)
		signal: aChildStructure title printString , ' can not be a child of ' , aParentStructure title printString! !

!PRStructureError class methodsFor: 'instance-creation' stamp: 'lr 3/9/2006 11:30'!
structure: aStructure
	^ self new
		setStructure: aStructure;
		yourself! !

!PRStructureError methodsFor: 'initialization' stamp: 'lr 3/9/2006 11:30'!
setStructure: aStructure
	structure := aStructure! !

!PRStructureError methodsFor: 'accessing' stamp: 'lr 3/9/2006 11:30'!
structure
	^ structure! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 5/24/2006 15:15'!
beEditable
	self propertyAt: #editable put: true! !

!MADescription methodsFor: '*pier-model' stamp: 'lr 5/24/2006 15:15'!
isEditable
	^ self propertyAt: #editable ifAbsent: [ false ]! !

!MABinaryReader methodsFor: '*pier-model-visiting-description' stamp: 'lr 3/9/2006 11:29'!
visitStructureDescription: aDescription
	self object
		write: (PRPathLookup
			start: self context root
			path: self stream next
			onError: [ nil ])
		using: aDescription! !
PRMacroExpander initialize!
